import 'moment/locale/de-ch';
import 'rxjs/add/observable/combineLatest';
import 'rxjs/add/observable/fromPromise';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/do';
import 'rxjs/add/operator/finally';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/publishReplay';
import 'rxjs/add/operator/share';
import 'rxjs/add/operator/switchMap';
import { curry, curryRight, findIndex, isEmpty, isNumber, isString, kebabCase, mapKeys, values } from 'lodash';
import moment from 'moment-es6';
import { BehaviorSubject as BehaviorSubject$1 } from 'rxjs/BehaviorSubject';
import { Observable as Observable$1 } from 'rxjs/Observable';
import { Subject as Subject$1 } from 'rxjs/Subject';
import * as DynamoDB from 'aws-sdk/clients/dynamodb';

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

/*! *****************************************************************************
Copyright (C) Microsoft. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
var Reflect$1;
(function (Reflect) {
    "use strict";
    var hasOwn = Object.prototype.hasOwnProperty;
    // feature test for Symbol support
    var supportsSymbol = typeof Symbol === "function";
    var toPrimitiveSymbol = supportsSymbol && typeof Symbol.toPrimitive !== "undefined" ? Symbol.toPrimitive : "@@toPrimitive";
    var iteratorSymbol = supportsSymbol && typeof Symbol.iterator !== "undefined" ? Symbol.iterator : "@@iterator";
    var HashMap;
    (function (HashMap) {
        var supportsCreate = typeof Object.create === "function"; // feature test for Object.create support
        var supportsProto = { __proto__: [] } instanceof Array; // feature test for __proto__ support
        var downLevel = !supportsCreate && !supportsProto;
        // create an object in dictionary mode (a.k.a. "slow" mode in v8)
        HashMap.create = supportsCreate
            ? function () { return MakeDictionary(Object.create(null)); }
            : supportsProto
                ? function () { return MakeDictionary({ __proto__: null }); }
                : function () { return MakeDictionary({}); };
        HashMap.has = downLevel
            ? function (map$$1, key) { return hasOwn.call(map$$1, key); }
            : function (map$$1, key) { return key in map$$1; };
        HashMap.get = downLevel
            ? function (map$$1, key) { return hasOwn.call(map$$1, key) ? map$$1[key] : undefined; }
            : function (map$$1, key) { return map$$1[key]; };
    })(HashMap || (HashMap = {}));
    // Load global or shim versions of Map, Set, and WeakMap
    var functionPrototype = Object.getPrototypeOf(Function);
    var usePolyfill = typeof process === "object" && process.env && process.env["REFLECT_METADATA_USE_MAP_POLYFILL"] === "true";
    var _Map = !usePolyfill && typeof Map === "function" && typeof Map.prototype.entries === "function" ? Map : CreateMapPolyfill();
    var _Set = !usePolyfill && typeof Set === "function" && typeof Set.prototype.entries === "function" ? Set : CreateSetPolyfill();
    var _WeakMap = !usePolyfill && typeof WeakMap === "function" ? WeakMap : CreateWeakMapPolyfill();
    // [[Metadata]] internal slot
    // https://rbuckton.github.io/reflect-metadata/#ordinary-object-internal-methods-and-internal-slots
    var Metadata = new _WeakMap();
    /**
      * Applies a set of decorators to a property of a target object.
      * @param decorators An array of decorators.
      * @param target The target object.
      * @param propertyKey (Optional) The property key to decorate.
      * @param attributes (Optional) The property descriptor for the target key.
      * @remarks Decorators are applied in reverse order.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     Example = Reflect.decorate(decoratorsArray, Example);
      *
      *     // property (on constructor)
      *     Reflect.decorate(decoratorsArray, Example, "staticProperty");
      *
      *     // property (on prototype)
      *     Reflect.decorate(decoratorsArray, Example.prototype, "property");
      *
      *     // method (on constructor)
      *     Object.defineProperty(Example, "staticMethod",
      *         Reflect.decorate(decoratorsArray, Example, "staticMethod",
      *             Object.getOwnPropertyDescriptor(Example, "staticMethod")));
      *
      *     // method (on prototype)
      *     Object.defineProperty(Example.prototype, "method",
      *         Reflect.decorate(decoratorsArray, Example.prototype, "method",
      *             Object.getOwnPropertyDescriptor(Example.prototype, "method")));
      *
      */
    function decorate(decorators, target, propertyKey, attributes) {
        if (!IsUndefined(propertyKey)) {
            if (!IsArray(decorators))
                throw new TypeError();
            if (!IsObject(target))
                throw new TypeError();
            if (!IsObject(attributes) && !IsUndefined(attributes) && !IsNull(attributes))
                throw new TypeError();
            if (IsNull(attributes))
                attributes = undefined;
            propertyKey = ToPropertyKey(propertyKey);
            return DecorateProperty(decorators, target, propertyKey, attributes);
        }
        else {
            if (!IsArray(decorators))
                throw new TypeError();
            if (!IsConstructor(target))
                throw new TypeError();
            return DecorateConstructor(decorators, target);
        }
    }
    Reflect.decorate = decorate;
    // 4.1.2 Reflect.metadata(metadataKey, metadataValue)
    // https://rbuckton.github.io/reflect-metadata/#reflect.metadata
    /**
      * A default metadata decorator factory that can be used on a class, class member, or parameter.
      * @param metadataKey The key for the metadata entry.
      * @param metadataValue The value for the metadata entry.
      * @returns A decorator function.
      * @remarks
      * If `metadataKey` is already defined for the target and target key, the
      * metadataValue for that key will be overwritten.
      * @example
      *
      *     // constructor
      *     @Reflect.metadata(key, value)
      *     class Example {
      *     }
      *
      *     // property (on constructor, TypeScript only)
      *     class Example {
      *         @Reflect.metadata(key, value)
      *         static staticProperty;
      *     }
      *
      *     // property (on prototype, TypeScript only)
      *     class Example {
      *         @Reflect.metadata(key, value)
      *         property;
      *     }
      *
      *     // method (on constructor)
      *     class Example {
      *         @Reflect.metadata(key, value)
      *         static staticMethod() { }
      *     }
      *
      *     // method (on prototype)
      *     class Example {
      *         @Reflect.metadata(key, value)
      *         method() { }
      *     }
      *
      */
    function metadata(metadataKey, metadataValue) {
        function decorator(target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey) && !IsPropertyKey(propertyKey))
                throw new TypeError();
            OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
        }
        return decorator;
    }
    Reflect.metadata = metadata;
    /**
      * Define a unique metadata entry on the target.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param metadataValue A value that contains attached metadata.
      * @param target The target object on which to define metadata.
      * @param propertyKey (Optional) The property key for the target.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     Reflect.defineMetadata("custom:annotation", options, Example);
      *
      *     // property (on constructor)
      *     Reflect.defineMetadata("custom:annotation", options, Example, "staticProperty");
      *
      *     // property (on prototype)
      *     Reflect.defineMetadata("custom:annotation", options, Example.prototype, "property");
      *
      *     // method (on constructor)
      *     Reflect.defineMetadata("custom:annotation", options, Example, "staticMethod");
      *
      *     // method (on prototype)
      *     Reflect.defineMetadata("custom:annotation", options, Example.prototype, "method");
      *
      *     // decorator factory as metadata-producing annotation.
      *     function MyAnnotation(options): Decorator {
      *         return (target, key?) => Reflect.defineMetadata("custom:annotation", options, target, key);
      *     }
      *
      */
    function defineMetadata(metadataKey, metadataValue, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
    }
    Reflect.defineMetadata = defineMetadata;
    /**
      * Gets a value indicating whether the target object or its prototype chain has the provided metadata key defined.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns `true` if the metadata key was defined on the target object or its prototype chain; otherwise, `false`.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.hasMetadata("custom:annotation", Example);
      *
      *     // property (on constructor)
      *     result = Reflect.hasMetadata("custom:annotation", Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.hasMetadata("custom:annotation", Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.hasMetadata("custom:annotation", Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.hasMetadata("custom:annotation", Example.prototype, "method");
      *
      */
    function hasMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryHasMetadata(metadataKey, target, propertyKey);
    }
    Reflect.hasMetadata = hasMetadata;
    /**
      * Gets a value indicating whether the target object has the provided metadata key defined.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns `true` if the metadata key was defined on the target object; otherwise, `false`.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.hasOwnMetadata("custom:annotation", Example);
      *
      *     // property (on constructor)
      *     result = Reflect.hasOwnMetadata("custom:annotation", Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.hasOwnMetadata("custom:annotation", Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.hasOwnMetadata("custom:annotation", Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.hasOwnMetadata("custom:annotation", Example.prototype, "method");
      *
      */
    function hasOwnMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryHasOwnMetadata(metadataKey, target, propertyKey);
    }
    Reflect.hasOwnMetadata = hasOwnMetadata;
    /**
      * Gets the metadata value for the provided metadata key on the target object or its prototype chain.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns The metadata value for the metadata key if found; otherwise, `undefined`.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.getMetadata("custom:annotation", Example);
      *
      *     // property (on constructor)
      *     result = Reflect.getMetadata("custom:annotation", Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.getMetadata("custom:annotation", Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.getMetadata("custom:annotation", Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.getMetadata("custom:annotation", Example.prototype, "method");
      *
      */
    function getMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryGetMetadata(metadataKey, target, propertyKey);
    }
    Reflect.getMetadata = getMetadata;
    /**
      * Gets the metadata value for the provided metadata key on the target object.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns The metadata value for the metadata key if found; otherwise, `undefined`.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.getOwnMetadata("custom:annotation", Example);
      *
      *     // property (on constructor)
      *     result = Reflect.getOwnMetadata("custom:annotation", Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.getOwnMetadata("custom:annotation", Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.getOwnMetadata("custom:annotation", Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.getOwnMetadata("custom:annotation", Example.prototype, "method");
      *
      */
    function getOwnMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryGetOwnMetadata(metadataKey, target, propertyKey);
    }
    Reflect.getOwnMetadata = getOwnMetadata;
    /**
      * Gets the metadata keys defined on the target object or its prototype chain.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns An array of unique metadata keys.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.getMetadataKeys(Example);
      *
      *     // property (on constructor)
      *     result = Reflect.getMetadataKeys(Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.getMetadataKeys(Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.getMetadataKeys(Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.getMetadataKeys(Example.prototype, "method");
      *
      */
    function getMetadataKeys(target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryMetadataKeys(target, propertyKey);
    }
    Reflect.getMetadataKeys = getMetadataKeys;
    /**
      * Gets the unique metadata keys defined on the target object.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns An array of unique metadata keys.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.getOwnMetadataKeys(Example);
      *
      *     // property (on constructor)
      *     result = Reflect.getOwnMetadataKeys(Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.getOwnMetadataKeys(Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.getOwnMetadataKeys(Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.getOwnMetadataKeys(Example.prototype, "method");
      *
      */
    function getOwnMetadataKeys(target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryOwnMetadataKeys(target, propertyKey);
    }
    Reflect.getOwnMetadataKeys = getOwnMetadataKeys;
    /**
      * Deletes the metadata entry from the target object with the provided key.
      * @param metadataKey A key used to store and retrieve metadata.
      * @param target The target object on which the metadata is defined.
      * @param propertyKey (Optional) The property key for the target.
      * @returns `true` if the metadata entry was found and deleted; otherwise, false.
      * @example
      *
      *     class Example {
      *         // property declarations are not part of ES6, though they are valid in TypeScript:
      *         // static staticProperty;
      *         // property;
      *
      *         constructor(p) { }
      *         static staticMethod(p) { }
      *         method(p) { }
      *     }
      *
      *     // constructor
      *     result = Reflect.deleteMetadata("custom:annotation", Example);
      *
      *     // property (on constructor)
      *     result = Reflect.deleteMetadata("custom:annotation", Example, "staticProperty");
      *
      *     // property (on prototype)
      *     result = Reflect.deleteMetadata("custom:annotation", Example.prototype, "property");
      *
      *     // method (on constructor)
      *     result = Reflect.deleteMetadata("custom:annotation", Example, "staticMethod");
      *
      *     // method (on prototype)
      *     result = Reflect.deleteMetadata("custom:annotation", Example.prototype, "method");
      *
      */
    function deleteMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
            throw new TypeError();
        if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
        var metadataMap = GetOrCreateMetadataMap(target, propertyKey, /*Create*/ false);
        if (IsUndefined(metadataMap))
            return false;
        if (!metadataMap.delete(metadataKey))
            return false;
        if (metadataMap.size > 0)
            return true;
        var targetMetadata = Metadata.get(target);
        targetMetadata.delete(propertyKey);
        if (targetMetadata.size > 0)
            return true;
        Metadata.delete(target);
        return true;
    }
    Reflect.deleteMetadata = deleteMetadata;
    function DecorateConstructor(decorators, target) {
        for (var i = decorators.length - 1; i >= 0; --i) {
            var decorator = decorators[i];
            var decorated = decorator(target);
            if (!IsUndefined(decorated) && !IsNull(decorated)) {
                if (!IsConstructor(decorated))
                    throw new TypeError();
                target = decorated;
            }
        }
        return target;
    }
    function DecorateProperty(decorators, target, propertyKey, descriptor) {
        for (var i = decorators.length - 1; i >= 0; --i) {
            var decorator = decorators[i];
            var decorated = decorator(target, propertyKey, descriptor);
            if (!IsUndefined(decorated) && !IsNull(decorated)) {
                if (!IsObject(decorated))
                    throw new TypeError();
                descriptor = decorated;
            }
        }
        return descriptor;
    }
    function GetOrCreateMetadataMap(O, P, Create) {
        var targetMetadata = Metadata.get(O);
        if (IsUndefined(targetMetadata)) {
            if (!Create)
                return undefined;
            targetMetadata = new _Map();
            Metadata.set(O, targetMetadata);
        }
        var metadataMap = targetMetadata.get(P);
        if (IsUndefined(metadataMap)) {
            if (!Create)
                return undefined;
            metadataMap = new _Map();
            targetMetadata.set(P, metadataMap);
        }
        return metadataMap;
    }
    // 3.1.1.1 OrdinaryHasMetadata(MetadataKey, O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinaryhasmetadata
    function OrdinaryHasMetadata(MetadataKey, O, P) {
        var hasOwn = OrdinaryHasOwnMetadata(MetadataKey, O, P);
        if (hasOwn)
            return true;
        var parent = OrdinaryGetPrototypeOf(O);
        if (!IsNull(parent))
            return OrdinaryHasMetadata(MetadataKey, parent, P);
        return false;
    }
    // 3.1.2.1 OrdinaryHasOwnMetadata(MetadataKey, O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinaryhasownmetadata
    function OrdinaryHasOwnMetadata(MetadataKey, O, P) {
        var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
        if (IsUndefined(metadataMap))
            return false;
        return ToBoolean(metadataMap.has(MetadataKey));
    }
    // 3.1.3.1 OrdinaryGetMetadata(MetadataKey, O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinarygetmetadata
    function OrdinaryGetMetadata(MetadataKey, O, P) {
        var hasOwn = OrdinaryHasOwnMetadata(MetadataKey, O, P);
        if (hasOwn)
            return OrdinaryGetOwnMetadata(MetadataKey, O, P);
        var parent = OrdinaryGetPrototypeOf(O);
        if (!IsNull(parent))
            return OrdinaryGetMetadata(MetadataKey, parent, P);
        return undefined;
    }
    // 3.1.4.1 OrdinaryGetOwnMetadata(MetadataKey, O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinarygetownmetadata
    function OrdinaryGetOwnMetadata(MetadataKey, O, P) {
        var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
        if (IsUndefined(metadataMap))
            return undefined;
        return metadataMap.get(MetadataKey);
    }
    // 3.1.5.1 OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinarydefineownmetadata
    function OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P) {
        var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ true);
        metadataMap.set(MetadataKey, MetadataValue);
    }
    // 3.1.6.1 OrdinaryMetadataKeys(O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinarymetadatakeys
    function OrdinaryMetadataKeys(O, P) {
        var ownKeys = OrdinaryOwnMetadataKeys(O, P);
        var parent = OrdinaryGetPrototypeOf(O);
        if (parent === null)
            return ownKeys;
        var parentKeys = OrdinaryMetadataKeys(parent, P);
        if (parentKeys.length <= 0)
            return ownKeys;
        if (ownKeys.length <= 0)
            return parentKeys;
        var set = new _Set();
        var keys = [];
        for (var _i = 0, ownKeys_1 = ownKeys; _i < ownKeys_1.length; _i++) {
            var key = ownKeys_1[_i];
            var hasKey = set.has(key);
            if (!hasKey) {
                set.add(key);
                keys.push(key);
            }
        }
        for (var _a = 0, parentKeys_1 = parentKeys; _a < parentKeys_1.length; _a++) {
            var key = parentKeys_1[_a];
            var hasKey = set.has(key);
            if (!hasKey) {
                set.add(key);
                keys.push(key);
            }
        }
        return keys;
    }
    // 3.1.7.1 OrdinaryOwnMetadataKeys(O, P)
    // https://rbuckton.github.io/reflect-metadata/#ordinaryownmetadatakeys
    function OrdinaryOwnMetadataKeys(O, P) {
        var keys = [];
        var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
        if (IsUndefined(metadataMap))
            return keys;
        var keysObj = metadataMap.keys();
        var iterator = GetIterator(keysObj);
        var k = 0;
        while (true) {
            var next = IteratorStep(iterator);
            if (!next) {
                keys.length = k;
                return keys;
            }
            var nextValue = IteratorValue(next);
            try {
                keys[k] = nextValue;
            }
            catch (e) {
                try {
                    IteratorClose(iterator);
                }
                finally {
                    throw e;
                }
            }
            k++;
        }
    }
    // 6 ECMAScript Data Typ0es and Values
    // https://tc39.github.io/ecma262/#sec-ecmascript-data-types-and-values
    function Type(x) {
        if (x === null)
            return 1 /* Null */;
        switch (typeof x) {
            case "undefined": return 0 /* Undefined */;
            case "boolean": return 2 /* Boolean */;
            case "string": return 3 /* String */;
            case "symbol": return 4 /* Symbol */;
            case "number": return 5 /* Number */;
            case "object": return x === null ? 1 /* Null */ : 6 /* Object */;
            default: return 6 /* Object */;
        }
    }
    // 6.1.1 The Undefined Type
    // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-undefined-type
    function IsUndefined(x) {
        return x === undefined;
    }
    // 6.1.2 The Null Type
    // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-null-type
    function IsNull(x) {
        return x === null;
    }
    // 6.1.5 The Symbol Type
    // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-symbol-type
    function IsSymbol(x) {
        return typeof x === "symbol";
    }
    // 6.1.7 The Object Type
    // https://tc39.github.io/ecma262/#sec-object-type
    function IsObject(x) {
        return typeof x === "object" ? x !== null : typeof x === "function";
    }
    // 7.1 Type Conversion
    // https://tc39.github.io/ecma262/#sec-type-conversion
    // 7.1.1 ToPrimitive(input [, PreferredType])
    // https://tc39.github.io/ecma262/#sec-toprimitive
    function ToPrimitive(input, PreferredType) {
        switch (Type(input)) {
            case 0 /* Undefined */: return input;
            case 1 /* Null */: return input;
            case 2 /* Boolean */: return input;
            case 3 /* String */: return input;
            case 4 /* Symbol */: return input;
            case 5 /* Number */: return input;
        }
        var hint = PreferredType === 3 /* String */ ? "string" : PreferredType === 5 /* Number */ ? "number" : "default";
        var exoticToPrim = GetMethod(input, toPrimitiveSymbol);
        if (exoticToPrim !== undefined) {
            var result = exoticToPrim.call(input, hint);
            if (IsObject(result))
                throw new TypeError();
            return result;
        }
        return OrdinaryToPrimitive(input, hint === "default" ? "number" : hint);
    }
    // 7.1.1.1 OrdinaryToPrimitive(O, hint)
    // https://tc39.github.io/ecma262/#sec-ordinarytoprimitive
    function OrdinaryToPrimitive(O, hint) {
        if (hint === "string") {
            var toString_1 = O.toString;
            if (IsCallable(toString_1)) {
                var result = toString_1.call(O);
                if (!IsObject(result))
                    return result;
            }
            var valueOf = O.valueOf;
            if (IsCallable(valueOf)) {
                var result = valueOf.call(O);
                if (!IsObject(result))
                    return result;
            }
        }
        else {
            var valueOf = O.valueOf;
            if (IsCallable(valueOf)) {
                var result = valueOf.call(O);
                if (!IsObject(result))
                    return result;
            }
            var toString_2 = O.toString;
            if (IsCallable(toString_2)) {
                var result = toString_2.call(O);
                if (!IsObject(result))
                    return result;
            }
        }
        throw new TypeError();
    }
    // 7.1.2 ToBoolean(argument)
    // https://tc39.github.io/ecma262/2016/#sec-toboolean
    function ToBoolean(argument) {
        return !!argument;
    }
    // 7.1.12 ToString(argument)
    // https://tc39.github.io/ecma262/#sec-tostring
    function ToString(argument) {
        return "" + argument;
    }
    // 7.1.14 ToPropertyKey(argument)
    // https://tc39.github.io/ecma262/#sec-topropertykey
    function ToPropertyKey(argument) {
        var key = ToPrimitive(argument, 3 /* String */);
        if (IsSymbol(key))
            return key;
        return ToString(key);
    }
    // 7.2 Testing and Comparison Operations
    // https://tc39.github.io/ecma262/#sec-testing-and-comparison-operations
    // 7.2.2 IsArray(argument)
    // https://tc39.github.io/ecma262/#sec-isarray
    function IsArray(argument) {
        return Array.isArray
            ? Array.isArray(argument)
            : argument instanceof Object
                ? argument instanceof Array
                : Object.prototype.toString.call(argument) === "[object Array]";
    }
    // 7.2.3 IsCallable(argument)
    // https://tc39.github.io/ecma262/#sec-iscallable
    function IsCallable(argument) {
        // NOTE: This is an approximation as we cannot check for [[Call]] internal method.
        return typeof argument === "function";
    }
    // 7.2.4 IsConstructor(argument)
    // https://tc39.github.io/ecma262/#sec-isconstructor
    function IsConstructor(argument) {
        // NOTE: This is an approximation as we cannot check for [[Construct]] internal method.
        return typeof argument === "function";
    }
    // 7.2.7 IsPropertyKey(argument)
    // https://tc39.github.io/ecma262/#sec-ispropertykey
    function IsPropertyKey(argument) {
        switch (Type(argument)) {
            case 3 /* String */: return true;
            case 4 /* Symbol */: return true;
            default: return false;
        }
    }
    // 7.3 Operations on Objects
    // https://tc39.github.io/ecma262/#sec-operations-on-objects
    // 7.3.9 GetMethod(V, P)
    // https://tc39.github.io/ecma262/#sec-getmethod
    function GetMethod(V, P) {
        var func = V[P];
        if (func === undefined || func === null)
            return undefined;
        if (!IsCallable(func))
            throw new TypeError();
        return func;
    }
    // 7.4 Operations on Iterator Objects
    // https://tc39.github.io/ecma262/#sec-operations-on-iterator-objects
    function GetIterator(obj) {
        var method = GetMethod(obj, iteratorSymbol);
        if (!IsCallable(method))
            throw new TypeError(); // from Call
        var iterator = method.call(obj);
        if (!IsObject(iterator))
            throw new TypeError();
        return iterator;
    }
    // 7.4.4 IteratorValue(iterResult)
    // https://tc39.github.io/ecma262/2016/#sec-iteratorvalue
    function IteratorValue(iterResult) {
        return iterResult.value;
    }
    // 7.4.5 IteratorStep(iterator)
    // https://tc39.github.io/ecma262/#sec-iteratorstep
    function IteratorStep(iterator) {
        var result = iterator.next();
        return result.done ? false : result;
    }
    // 7.4.6 IteratorClose(iterator, completion)
    // https://tc39.github.io/ecma262/#sec-iteratorclose
    function IteratorClose(iterator) {
        var f = iterator["return"];
        if (f)
            f.call(iterator);
    }
    // 9.1 Ordinary Object Internal Methods and Internal Slots
    // https://tc39.github.io/ecma262/#sec-ordinary-object-internal-methods-and-internal-slots
    // 9.1.1.1 OrdinaryGetPrototypeOf(O)
    // https://tc39.github.io/ecma262/#sec-ordinarygetprototypeof
    function OrdinaryGetPrototypeOf(O) {
        var proto = Object.getPrototypeOf(O);
        if (typeof O !== "function" || O === functionPrototype)
            return proto;
        // TypeScript doesn't set __proto__ in ES5, as it's non-standard.
        // Try to determine the superclass constructor. Compatible implementations
        // must either set __proto__ on a subclass constructor to the superclass constructor,
        // or ensure each class has a valid `constructor` property on its prototype that
        // points back to the constructor.
        // If this is not the same as Function.[[Prototype]], then this is definately inherited.
        // This is the case when in ES6 or when using __proto__ in a compatible browser.
        if (proto !== functionPrototype)
            return proto;
        // If the super prototype is Object.prototype, null, or undefined, then we cannot determine the heritage.
        var prototype = O.prototype;
        var prototypeProto = prototype && Object.getPrototypeOf(prototype);
        if (prototypeProto == null || prototypeProto === Object.prototype)
            return proto;
        // If the constructor was not a function, then we cannot determine the heritage.
        var constructor = prototypeProto.constructor;
        if (typeof constructor !== "function")
            return proto;
        // If we have some kind of self-reference, then we cannot determine the heritage.
        if (constructor === O)
            return proto;
        // we have a pretty good guess at the heritage.
        return constructor;
    }
    // naive Map shim
    function CreateMapPolyfill() {
        var cacheSentinel = {};
        var arraySentinel = [];
        var MapIterator = (function () {
            function MapIterator(keys, values$$1, selector) {
                this._index = 0;
                this._keys = keys;
                this._values = values$$1;
                this._selector = selector;
            }
            MapIterator.prototype["@@iterator"] = function () { return this; };
            MapIterator.prototype[iteratorSymbol] = function () { return this; };
            MapIterator.prototype.next = function () {
                var index = this._index;
                if (index >= 0 && index < this._keys.length) {
                    var result = this._selector(this._keys[index], this._values[index]);
                    if (index + 1 >= this._keys.length) {
                        this._index = -1;
                        this._keys = arraySentinel;
                        this._values = arraySentinel;
                    }
                    else {
                        this._index++;
                    }
                    return { value: result, done: false };
                }
                return { value: undefined, done: true };
            };
            MapIterator.prototype.throw = function (error) {
                if (this._index >= 0) {
                    this._index = -1;
                    this._keys = arraySentinel;
                    this._values = arraySentinel;
                }
                throw error;
            };
            MapIterator.prototype.return = function (value) {
                if (this._index >= 0) {
                    this._index = -1;
                    this._keys = arraySentinel;
                    this._values = arraySentinel;
                }
                return { value: value, done: true };
            };
            return MapIterator;
        }());
        return (function () {
            function Map() {
                this._keys = [];
                this._values = [];
                this._cacheKey = cacheSentinel;
                this._cacheIndex = -2;
            }
            Object.defineProperty(Map.prototype, "size", {
                get: function () { return this._keys.length; },
                enumerable: true,
                configurable: true
            });
            Map.prototype.has = function (key) { return this._find(key, /*insert*/ false) >= 0; };
            Map.prototype.get = function (key) {
                var index = this._find(key, /*insert*/ false);
                return index >= 0 ? this._values[index] : undefined;
            };
            Map.prototype.set = function (key, value) {
                var index = this._find(key, /*insert*/ true);
                this._values[index] = value;
                return this;
            };
            Map.prototype.delete = function (key) {
                var index = this._find(key, /*insert*/ false);
                if (index >= 0) {
                    var size = this._keys.length;
                    for (var i = index + 1; i < size; i++) {
                        this._keys[i - 1] = this._keys[i];
                        this._values[i - 1] = this._values[i];
                    }
                    this._keys.length--;
                    this._values.length--;
                    if (key === this._cacheKey) {
                        this._cacheKey = cacheSentinel;
                        this._cacheIndex = -2;
                    }
                    return true;
                }
                return false;
            };
            Map.prototype.clear = function () {
                this._keys.length = 0;
                this._values.length = 0;
                this._cacheKey = cacheSentinel;
                this._cacheIndex = -2;
            };
            Map.prototype.keys = function () { return new MapIterator(this._keys, this._values, getKey); };
            Map.prototype.values = function () { return new MapIterator(this._keys, this._values, getValue); };
            Map.prototype.entries = function () { return new MapIterator(this._keys, this._values, getEntry); };
            Map.prototype["@@iterator"] = function () { return this.entries(); };
            Map.prototype[iteratorSymbol] = function () { return this.entries(); };
            Map.prototype._find = function (key, insert) {
                if (this._cacheKey !== key) {
                    this._cacheIndex = this._keys.indexOf(this._cacheKey = key);
                }
                if (this._cacheIndex < 0 && insert) {
                    this._cacheIndex = this._keys.length;
                    this._keys.push(key);
                    this._values.push(undefined);
                }
                return this._cacheIndex;
            };
            return Map;
        }());
        function getKey(key, _) {
            return key;
        }
        function getValue(_, value) {
            return value;
        }
        function getEntry(key, value) {
            return [key, value];
        }
    }
    // naive Set shim
    function CreateSetPolyfill() {
        return (function () {
            function Set() {
                this._map = new _Map();
            }
            Object.defineProperty(Set.prototype, "size", {
                get: function () { return this._map.size; },
                enumerable: true,
                configurable: true
            });
            Set.prototype.has = function (value) { return this._map.has(value); };
            Set.prototype.add = function (value) { return this._map.set(value, value), this; };
            Set.prototype.delete = function (value) { return this._map.delete(value); };
            Set.prototype.clear = function () { this._map.clear(); };
            Set.prototype.keys = function () { return this._map.keys(); };
            Set.prototype.values = function () { return this._map.values(); };
            Set.prototype.entries = function () { return this._map.entries(); };
            Set.prototype["@@iterator"] = function () { return this.keys(); };
            Set.prototype[iteratorSymbol] = function () { return this.keys(); };
            return Set;
        }());
    }
    // naive WeakMap shim
    function CreateWeakMapPolyfill() {
        var UUID_SIZE = 16;
        var keys = HashMap.create();
        var rootKey = CreateUniqueKey();
        return (function () {
            function WeakMap() {
                this._key = CreateUniqueKey();
            }
            WeakMap.prototype.has = function (target) {
                var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                return table !== undefined ? HashMap.has(table, this._key) : false;
            };
            WeakMap.prototype.get = function (target) {
                var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                return table !== undefined ? HashMap.get(table, this._key) : undefined;
            };
            WeakMap.prototype.set = function (target, value) {
                var table = GetOrCreateWeakMapTable(target, /*create*/ true);
                table[this._key] = value;
                return this;
            };
            WeakMap.prototype.delete = function (target) {
                var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                return table !== undefined ? delete table[this._key] : false;
            };
            WeakMap.prototype.clear = function () {
                // NOTE: not a real clear, just makes the previous data unreachable
                this._key = CreateUniqueKey();
            };
            return WeakMap;
        }());
        function CreateUniqueKey() {
            var key;
            do
                key = "@@WeakMap@@" + CreateUUID();
            while (HashMap.has(keys, key));
            keys[key] = true;
            return key;
        }
        function GetOrCreateWeakMapTable(target, create) {
            if (!hasOwn.call(target, rootKey)) {
                if (!create)
                    return undefined;
                Object.defineProperty(target, rootKey, { value: HashMap.create() });
            }
            return target[rootKey];
        }
        function FillRandomBytes(buffer, size) {
            for (var i = 0; i < size; ++i)
                buffer[i] = Math.random() * 0xff | 0;
            return buffer;
        }
        function GenRandomBytes(size) {
            if (typeof Uint8Array === "function") {
                if (typeof crypto !== "undefined")
                    return crypto.getRandomValues(new Uint8Array(size));
                if (typeof msCrypto !== "undefined")
                    return msCrypto.getRandomValues(new Uint8Array(size));
                return FillRandomBytes(new Uint8Array(size), size);
            }
            return FillRandomBytes(new Array(size), size);
        }
        function CreateUUID() {
            var data = GenRandomBytes(UUID_SIZE);
            // mark as random - RFC 4122 § 4.4
            data[6] = data[6] & 0x4f | 0x40;
            data[8] = data[8] & 0xbf | 0x80;
            var result = "";
            for (var offset = 0; offset < UUID_SIZE; ++offset) {
                var byte = data[offset];
                if (offset === 4 || offset === 6 || offset === 8)
                    result += "-";
                if (byte < 16)
                    result += "0";
                result += byte.toString(16).toLowerCase();
            }
            return result;
        }
    }
    // uses a heuristic used by v8 and chakra to force an object into dictionary mode.
    function MakeDictionary(obj) {
        obj.__ = undefined;
        delete obj.__;
        return obj;
    }
    // patch global Reflect
    (function (__global) {
        if (typeof __global.Reflect !== "undefined") {
            if (__global.Reflect !== Reflect) {
                for (var p in Reflect) {
                    if (hasOwn.call(Reflect, p)) {
                        __global.Reflect[p] = Reflect[p];
                    }
                }
            }
        }
        else {
            __global.Reflect = Reflect;
        }
    })(typeof commonjsGlobal !== "undefined" ? commonjsGlobal :
        typeof self !== "undefined" ? self :
            Function("return this;")());
})(Reflect$1 || (Reflect$1 = {}));

class MomentType {
}

// TODO is this enough for marker class, or is any unique id required to be sure it is the Binary marker class
class Binary {
    constructor() { }
}

class NullType {
}

class UndefinedType {
}

const BUFFER_TYPES = [
    'Buffer',
    'File',
    'Blob',
    'ArrayBuffer',
    'DataView',
    'Int8Array',
    'Uint8Array',
    'Uint8ClampedArray',
    'Int16Array',
    'Uint16Array',
    'Int32Array',
    'Uint32Array',
    'Float32Array',
    'Float64Array',
];
class Util {
    // TODO should we handle duplicates, switch from set to list?
    static detectCollectionType(collection) {
        if (Array.isArray(collection)) {
            if (collection.every(isString)) {
                return 'SS';
            }
            if (collection.every(isNumber)) {
                return 'NS';
            }
            if (collection.every(Util.isBinary)) {
                return 'BS';
            }
            return 'L';
        }
        else if (Util.isSet(collection)) {
            const firstValueType = collection.size ? collection.values().next().value : null;
            const type = Util.detectType(firstValueType);
            switch (type) {
                case 'S':
                    return 'SS';
                case 'N':
                    return 'NS';
                case 'B':
                    return 'BS';
                default:
                    return 'L';
            }
        }
        else {
            throw new Error('given collection was no array or Set -> type could not be detected');
        }
    }
    static typeByConvention(propertyKey) {
        let type;
        Object.keys(Util.REGEX_CONVENTIONS).forEach(key => {
            if (Util.REGEX_CONVENTIONS[key].test(propertyKey)) {
                type = key;
            }
        });
        return type;
    }
    static isCollection(value) {
        return value && (Array.isArray(value) || Util.isSet(value));
    }
    static isSet(value) {
        return ((value !== null && value !== undefined && value.hasOwnProperty('name') && value.name === 'Set') ||
            value instanceof Set);
    }
    // FIXME should we handle duplicates -> switch to L(ist) instead of S(et)
    static detectType(value) {
        if (Util.isCollection(value)) {
            return Util.detectCollectionType(value);
        }
        else {
            if (isString(value)) {
                return 'S';
            }
            if (isNumber(value)) {
                return 'N';
            }
            if (Util.isBinary(value)) {
                return 'B';
            }
            if (value === null) {
                return 'NULL';
            }
            if (typeof value === 'boolean') {
                return 'BOOL';
            }
            if (typeof value === 'object') {
                return 'M';
            }
        }
        throw new Error(`the type for value ${value} could not be detected`);
    }
    /**
     * Will resolve the type based on given data.
     *
     * @param data
     * @returns {AttributeModelTypeName}
     */
    static typeOf(data) {
        if (data === null) {
            return NullType;
        }
        else {
            if (Array.isArray(data)) {
                return Array;
            }
            else if (data instanceof Set) {
                return Set;
            }
            else if (data instanceof Map) {
                return Map;
            }
            else if (data instanceof Date) {
                return Date;
            }
            else if (moment.isMoment(data)) {
                return MomentType;
            }
            else if (Util.isBinary(data)) {
                return Binary;
            }
            else {
                switch (typeof data) {
                    case 'string':
                        return String;
                    case 'number':
                        return Number;
                    case 'boolean':
                        return Boolean;
                    case 'undefined':
                        return UndefinedType;
                    case 'object':
                        return Object;
                }
            }
        }
        throw new Error(`typeof data ${data} could not be detected`);
    }
    /*
     * copied from https://github.com/aws/aws-sdk-js/blob/0c974a7ff6749a541594de584b43a040978d4b72/lib/dynamodb/types.js
     * should we work with string match
     */
    static typeOfFromDb(attributeValue) {
        if (attributeValue) {
            const dynamoType = Object.keys(attributeValue)[0];
            switch (dynamoType) {
                case 'S':
                    if (Util.DATE_TIME_ISO8601.test(attributeValue.S)) {
                        return MomentType;
                    }
                    else {
                        return String;
                    }
                case 'N':
                    return Number;
                case 'B':
                    return Binary;
                case 'BOOL':
                    return Boolean;
                case 'SS':
                case 'NS':
                case 'BS':
                    return Set;
                case 'L':
                    return Array;
                case 'M':
                    return Object;
                case 'NULL':
                    return NullType;
            }
        }
        throw new Error(`could not resolve the dynamo db type for attribute value ${attributeValue}`);
    }
    static isBinary(data) {
        if (Util.isNode()) {
            // FIXME should add || data instanceof Stream
            return Buffer.isBuffer(data);
        }
        else {
            BUFFER_TYPES.forEach(type => {
                if (data !== undefined && data.constructor) {
                    if (Util.isType(data, type)) {
                        return true;
                    }
                    else if (Util.typeName(data.constructor) === type) {
                        return true;
                    }
                }
            });
        }
        return false;
    }
    static isBufferType(type) {
        return BUFFER_TYPES.includes(type);
    }
    /*
     * copied from https://github.com/aws/aws-sdk-js/blob/0c974a7ff6749a541594de584b43a040978d4b72/lib/util.js
     */
    static isType(obj, type) {
        // handle cross-"frame" objects
        if (typeof type === 'function') {
            type = Util.typeName(type);
        }
        return Object.prototype.toString.call(obj) === '[object ' + type + ']';
    }
    static isBrowser() {
        return process && process.browser;
    }
    static isNode() {
        return !Util.isBrowser();
    }
    /**
     * Returns the name of the given Type. null and undefined are special cases were we return 'Null' vs. 'Undefined'
     * @param type
     * @returns {string}
     */
    static typeName(type) {
        if (type !== null && type !== undefined) {
            if (Object.prototype.hasOwnProperty.call(type, 'name')) {
                return type.name;
            }
            else {
                const str = type.toString();
                const match = str.match(/^\s*function (.+)\(/);
                return match ? match[1] : str;
            }
        }
        else {
            if (type === null) {
                return 'Null';
            }
            else if (type === undefined) {
                return 'Undefined';
            }
        }
        throw new Error(`was not able to resolve type name for type ${type}`);
    }
    // FIXME replace with a more bullet proof implementation node uuid module requires crypto, need to figure out how to use it with browser
    static uuidv4() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, c => {
            // tslint:disable
            let r = (Math.random() * 16) | 0, v = c == 'x' ? r : (r & 0x3) | 0x8;
            return v.toString(16);
        });
    }
}
Util.REGEX_CONVENTIONS = {
    date: /^(?:date|[\w]+(?:Date|At)(?:[A-Z]{1}[\w]+)?)$/,
};
// tslint:disable-next-line:max-line-length
Util.DATE_TIME_ISO8601 = /^(?:[1-9]\d{3}-(?:(?:0[1-9]|1[0-2])-(?:0[1-9]|1\d|2[0-8])|(?:0[13-9]|1[0-2])-(?:29|30)|(?:0[13578]|1[02])-31)|(?:[1-9]\d(?:0[48]|[2468][048]|[13579][26])|(?:[2468][048]|[13579][26])00)-02-29)T(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:Z|[+-][01]\d:[0-5]\d)$/;

// these reflection keys are built in using the reflect-metadata library
const KEY_TYPE = 'design:type';
const KEY_PARAMETER = 'design:paramtypes';
const KEY_RETURN_TYPE = 'design:returntype';
const getMetadataType = makeMetadataGetter(KEY_TYPE);
function makeMetadataGetter(metadataKey) {
    return (target, targetKey) => {
        if (targetKey) {
            return Reflect.getMetadata(metadataKey, target, targetKey);
        }
        else {
            return Reflect.getMetadata(metadataKey, target);
        }
    };
}

var IndexType;
(function (IndexType) {
    IndexType[IndexType["GSI"] = 0] = "GSI";
    IndexType[IndexType["LSI"] = 1] = "LSI";
})(IndexType || (IndexType = {}));

const KEY_PROPERTY = 'sc-reflect:property';
function Property(opts = {}) {
    return (target, propertyKey) => {
        const propertyOptions = {
            name: propertyKey,
            nameDb: opts.name || propertyKey,
        };
        initOrUpdateProperty(propertyOptions, target, propertyKey);
    };
}
function initOrUpdateIndex(indexType, indexData, target, propertyKey) {
    const properties = Reflect.getMetadata(KEY_PROPERTY, target.constructor) || [];
    const existingProperty = properties.find(property => property.name === propertyKey);
    let propertyMetadata;
    switch (indexType) {
        case IndexType.GSI:
            propertyMetadata = initOrUpdateGSI(existingProperty && existingProperty.keyForGSI ? existingProperty.keyForGSI : {}, indexData);
            break;
        case IndexType.LSI:
            propertyMetadata = initOrUpdateLSI(existingProperty && existingProperty.sortKeyForLSI ? existingProperty.sortKeyForLSI : [], indexData);
            break;
        default:
            throw new Error(`unsupported index type ${indexType}`);
    }
    initOrUpdateProperty(propertyMetadata, target, propertyKey);
}
function initOrUpdateGSI(indexes, indexData) {
    if (indexes[indexData.name]) {
        // TODO when we throw an error we have a problem where multiple different classes extend one base class, this will be executed by multiple times
        // throw new Error(
        //   'the property with name is already registered as key for index - one property can only define one key per index'
        // )
    }
    else {
        indexes[indexData.name] = indexData.keyType;
    }
    return { keyForGSI: indexes };
}
function initOrUpdateLSI(indexes, indexData) {
    indexes.push(indexData.name);
    return { sortKeyForLSI: indexes };
}
function initOrUpdateProperty(propertyMetadata = {}, target, propertyKey) {
    // Update the attribute array
    const properties = Reflect.getMetadata(KEY_PROPERTY, target.constructor) || [];
    const existingProperty = properties.find(property => property.name === propertyKey);
    if (existingProperty) {
        // merge property options
        // console.log('merge into existing property', existingProperty, propertyMetadata);
        Object.assign(existingProperty, propertyMetadata);
    }
    else {
        // add new options
        const newProperty = createNewProperty(propertyMetadata, target, propertyKey);
        // console.log('new property', newProperty);
        properties.push(newProperty);
    }
    Reflect.defineMetadata(KEY_PROPERTY, properties, target.constructor);
}
function createNewProperty(propertyOptions = {}, target, propertyKey) {
    let propertyType = getMetadataType(target, propertyKey);
    let customType = isCustomType(propertyType);
    // FIXME model metadata is not accessible here, need to know the model data for metadatintorspection
    // let modelMetadata: ModelMetadata = Reflect.getMetadata(KEY_MODEL, target.constructor);
    const typeByConvention = Util.typeByConvention(propertyKey);
    if (typeByConvention) {
        customType = true;
        if (ScDynamoObjectMapper.config) {
            switch (typeByConvention) {
                case 'date':
                    switch (ScDynamoObjectMapper.config.dateType) {
                        case 'default':
                            propertyType = Date;
                            break;
                        case 'moment':
                            propertyType = MomentType;
                            break;
                        default:
                            throw new Error(`Unsupported date type on model metadata <${ScDynamoObjectMapper.config.dateType}>`);
                    }
                    break;
            }
        }
    }
    const propertyDescriptor = Reflect.getOwnPropertyDescriptor(target, propertyKey);
    const typeInfo = {
        type: propertyType,
        isCustom: customType,
    };
    // console.log(`#### propertyKey: ${propertyKey} / typeInfo: ${JSON.stringify(typeInfo)}`);
    propertyOptions = Object.assign({ name: propertyKey, nameDb: propertyKey, typeInfo }, propertyOptions);
    return propertyOptions;
}
/**
 * FIXME fix typing
 * FIXME make sure to implement the context dependant details of Binary (Buffer vs. Uint8Array)
 * @returns {boolean} true if the type cannot be mapped by dynamo document client
 */
function isCustomType(type) {
    return type !== String && type !== Number && type !== Boolean && type !== Uint8Array;
}

/**
 * Makes sure the property will be marshalled to a L(ist) type. The modelClass is required if the array items
 * have some property decorators, so we can retrieve this information using the model class.
 *
 * @param {ModelConstructor<any>} modelClass
 * @returns {PropertyDecorator}
 * @constructor
 */
// FIXME is there any improvement if we add generics to SortedSet<T> is it even possible?
function SortedSet(modelClass) {
    return (target, propertyKey) => {
        const typeInfo = {
            type: Set,
            typeName: 'Set',
            isCustom: true,
        };
        if (modelClass) {
            typeInfo.genericTypes = [modelClass];
        }
        initOrUpdateProperty({ isSortedCollection: true, typeInfo }, target, propertyKey);
    };
}

/**
 * Makes sure the property will be marshalled to a S(et) type. The modelClass is required for additional type saftey
 * or if the items have a complex type
 *
 * @param {ModelConstructor<any>} modelClass
 * @returns {PropertyDecorator}
 * @constructor
 */
// TODO TypedSet naming is somewhat misleading, because it does not require a type, it is always typed thats true
// FIXME is there any improvement if we add generics to SortedSet<T> is it even possible?
function TypedSet(modelClass) {
    return (target, propertyKey) => {
        const typeInfo = {
            type: Set,
            typeName: 'Set',
            isCustom: true,
        };
        if (modelClass) {
            typeInfo.genericTypes = [modelClass];
        }
        initOrUpdateProperty({ typeInfo }, target, propertyKey);
    };
}

/**
 * Makes sure the property will be marshalled to a L(ist) type. The modelClass is required if the array items
 * have some property decorators, so we can retrieve this information using the model class.
 *
 * @param {ModelConstructor<any>} modelClass
 * @returns {PropertyDecorator}
 * @constructor
 *
 * FIXME rename (collision with es.Array)
 */
function TypedArray(modelClass) {
    return (target, propertyKey) => {
        const typeInfo = {
            type: Array,
            isCustom: true,
        };
        if (modelClass) {
            typeInfo.genericTypes = [modelClass];
        }
        initOrUpdateProperty({ typeInfo }, target, propertyKey);
    };
}

function Date$1() {
    return (target, propertyKey) => {
        // check the global config to decide which dat type we should use
        let dateType;
        switch (ScDynamoObjectMapper.config.dateType) {
            case 'default':
                dateType = Date$1;
                break;
            case 'moment':
                dateType = MomentType;
                break;
        }
        const typeInfo = {
            type: dateType,
            typeName: Util.typeName(dateType),
            isCustom: true,
        };
        initOrUpdateProperty({ typeInfo }, target, propertyKey);
    };
}

function GSIPartitionKey(indexName) {
    return (target, propertyKey) => {
        initOrUpdateIndex(IndexType.GSI, { name: indexName, keyType: 'HASH' }, target, propertyKey);
    };
}

function GSISortKey(indexName) {
    return (target, propertyKey) => {
        initOrUpdateIndex(IndexType.GSI, { name: indexName, keyType: 'RANGE' }, target, propertyKey);
    };
}

/**
 * Marks a property as the sort key attribute of a local secondary index (the partition key must be same as in base table)
 *
 * @param {string} indexName Name of the local secondary index
 * @returns {PropertyDecorator}
 */
function LSISortKey(indexName) {
    return (target, propertyKey) => {
        initOrUpdateIndex(IndexType.LSI, { name: indexName, keyType: 'RANGE' }, target, propertyKey);
    };
}

// TODO check for type of partition key only some scalars are allowed, there could be a custom mapper and the order of decorators cannot be guaranted
function PartitionKey() {
    return (target, propertyKey) => {
        // check for existing properties marked as partition key
        const properties = Reflect.getMetadata(KEY_PROPERTY, target.constructor) || [];
        if (properties && properties.length) {
            const existingPartitionKeys = properties.filter(property => property.key && property.key.type === 'HASH');
            if (existingPartitionKeys.length) {
                if (properties.find(property => property.name === propertyKey)) {
                    // just ignore this and go on, somehow the partition key gets defined
                    // tslint:disable-next-line:no-console
                    console.warn(`this is the second execution to define the paritionKey for propety ${propertyKey}`);
                }
                else {
                    throw new Error('only one partition key is allowed per model, if you want to define key for indexes use one of these decorators: ' +
                        '@GSIPartitionKey,  @GSISortKey or @LSISortKey');
                }
            }
        }
        initOrUpdateProperty({ key: { type: 'HASH' } }, target, propertyKey);
    };
}

function PartitionKeyUUID() {
    return (target, propertyKey) => {
        initOrUpdateProperty({ key: { type: 'HASH', uuid: true } }, target, propertyKey);
    };
}

function SortKey() {
    return (target, propertyKey) => {
        initOrUpdateProperty({ key: { type: 'RANGE' } }, target, propertyKey);
    };
}

// FIXME add type for MapperForPartitionKey, which limits to the allowed type of dynamodb partition keys
// FIXME check for type of partition key only some scalars are allowed
// TODO add binary as possible value
function CustomMapper(mapperClazz) {
    return (target, propertyKey) => {
        initOrUpdateProperty({ mapper: mapperClazz }, target, propertyKey);
    };
}

// FIXME should be optional dependency
const KEY_MODEL = 'sc-reflect:model';
/*
 * FIXME add validation for tableName
 * Table names and index names must be between 3 and 255 characters long, and can contain only the following characters:
a-z
A-Z
0-9
_ (underscore)
- (dash)
. (dot)
 */
function Model(opts = {}) {
    // tslint:disable-next-line:ban-types
    return (constructor) => {
        // Make sure everything is valid
        const classType = getMetadataType(constructor);
        const type = constructor;
        // FIXME would better typing help with something
        // get all the properties with @Property() annotation
        const properties = Reflect.getOwnMetadata(KEY_PROPERTY, constructor);
        // get partition key
        const partitionKeys = properties
            ? properties.filter(property => property.key && property.key.type === 'HASH')
            : null;
        const partitionKeyName = partitionKeys && partitionKeys.length ? partitionKeys[0].nameDb : null;
        /*
         * get the local and global secondary indexes
         */
        const globalSecondaryIndexes = getGlobalSecondaryIndexes(properties) || [];
        const localSecondaryIndexes = getLocalSecondaryIndexes(partitionKeyName, properties) || [];
        const indexes = new Map([...globalSecondaryIndexes, ...localSecondaryIndexes]);
        const transientProperties = properties && properties.length
            ? properties.filter(property => property.transient === true).map(property => property.name)
            : [];
        const finalOpts = Object.assign({ clazz: constructor, clazzName: type.name, tableName: `${kebabCase(type.name)}s`, properties,
            transientProperties,
            indexes }, opts);
        // console.log(`Decorating: ${finalOpts.clazzName}`, finalOpts);
        Reflect.defineMetadata(KEY_MODEL, finalOpts, constructor);
    };
}
// TODO VALIDATION only 5 gsi are allowed per table
function getGlobalSecondaryIndexes(properties) {
    if (properties && properties.length) {
        return properties
            .filter(property => property.keyForGSI && Object.keys(property.keyForGSI).length)
            .reduce((map$$1, property) => {
            let gsi;
            Object.keys(property.keyForGSI).forEach(indexName => {
                if (map$$1.has(indexName)) {
                    gsi = map$$1.get(indexName);
                }
                else {
                    gsi = {};
                }
                switch (property.keyForGSI[indexName]) {
                    case 'HASH':
                        if (gsi.partitionKey) {
                            throw new Error(`there is already a partition key defined for global secondary index ${indexName} (property name: ${property.nameDb})`);
                        }
                        gsi.partitionKey = property.nameDb;
                        break;
                    case 'RANGE':
                        if (gsi.sortKey) {
                            throw new Error(`there is already a sort key defined for global secondary index ${indexName} (property name: ${property.nameDb})`);
                        }
                        gsi.sortKey = property.nameDb;
                        break;
                }
                if (map$$1.has(indexName)) {
                    map$$1.set(indexName, gsi);
                }
                else {
                    if (map$$1.size < 5) {
                        map$$1.set(indexName, gsi);
                    }
                    else {
                        // a maximum of 5 global secondary indexes can be defined per table
                        throw new Error('make sure to define no more than 5 global secondary indexes per model');
                    }
                }
            });
            return map$$1;
        }, new Map());
    }
    else {
        return null;
    }
}
function getLocalSecondaryIndexes(basePartitionKey, properties) {
    if (properties && properties.length) {
        return properties
            .filter(property => property.sortKeyForLSI && property.sortKeyForLSI.length)
            .reduce((map$$1, property) => {
            let lsi;
            property.sortKeyForLSI.forEach(indexName => {
                if (map$$1.has(indexName)) {
                    throw new Error(`only one sort key can be defined for the same local secondary index, ${property.nameDb} is already defined as sort key for index ${indexName}`);
                }
                if (!basePartitionKey) {
                    throw new Error('a local secondary index requires the partition key to be defined, use the @PartitionKey decorator');
                }
                lsi = {
                    partitionKey: basePartitionKey,
                    sortKey: property.nameDb,
                };
                map$$1.set(indexName, lsi);
            });
            return map$$1;
        }, new Map());
    }
    else {
        return null;
    }
}

function Transient() {
    return (target, propertyKey) => {
        initOrUpdateProperty({ transient: true }, target, propertyKey);
    };
}

class EnumType {
}

function Enum() {
    return (target, propertyKey) => {
        initOrUpdateProperty({ typeInfo: { type: EnumType, isCustom: true } }, target, propertyKey);
    };
}

class Metadata {
    constructor(modelClass) {
        this.modelOptions = Reflect.getMetadata(KEY_MODEL, modelClass);
    }
    forProperty(propertyKey) {
        let options;
        if (this.modelOptions.properties) {
            options = this.modelOptions.properties.find(property => property.name === propertyKey || property.nameDb === propertyKey);
        }
        return options;
    }
    /**
     *
     * @returns {Array<PropertyMetadata<any>>} Returns all the properties property the @PartitionKeyUUID decorator is present, returns an empty array by default
     */
    getKeysWithUUID() {
        return this.filterBy(p => !!(p.key && p.key.uuid), []);
    }
    /**
     * @param {string} indexName
     * @returns {string} Returns the name of partition key (not the db name if it differs from property name)
     * @throws Throws an error if no partition key was defined for the current model
     * @throws Throws an error if an indexName was delivered but no index was found for given name
     */
    getPartitionKey(indexName) {
        if (indexName) {
            const index = this.getIndex(indexName);
            if (index) {
                return index.partitionKey;
            }
            else {
                throw new Error(`there is no index defined for name ${indexName}`);
            }
        }
        else {
            const property = this.filterByFirst(p => !!(p.key && p.key.type === 'HASH'));
            if (property) {
                return property.name;
            }
            else {
                throw new Error('could not find any partition key');
            }
        }
    }
    /**
     * @param {string} indexName
     * @returns {keyof T} Returns the name of sort key (not the db name if it differs from property name) or null if none was defined
     * @throws Throws an error if an indexName was delivered but no index was found for given name or the found index has no sort key defined
     */
    getSortKey(indexName) {
        if (indexName) {
            const index = this.getIndex(indexName);
            if (index) {
                if (index.sortKey) {
                    return index.sortKey;
                }
                else {
                    throw new Error(`there is no sort key defined for index ${indexName}`);
                }
            }
            else {
                throw new Error(`there is no index defined for name ${indexName}`);
            }
        }
        else {
            const property = this.filterByFirst(p => !!(p.key && p.key.type === 'RANGE'));
            return property ? property.name : null;
        }
    }
    /**
     *
     * @returns {SecondaryIndex[]} Returns all the secondary indexes if exists or an empty array if none is defined
     */
    getIndexes() {
        if (this.modelOptions.indexes && this.modelOptions.indexes.size) {
            return Array.from(this.modelOptions.indexes.values());
        }
        else {
            return [];
        }
    }
    /**
     * @param {string} indexName
     * @returns {SecondaryIndex} Returns the index if one with given name exists, null otherwise
     */
    getIndex(indexName) {
        if (this.modelOptions.indexes) {
            const index = this.modelOptions.indexes.get(indexName);
            return index ? index : null;
        }
        return null;
    }
    filterBy(predicate, defaultValue) {
        if (this.modelOptions && this.modelOptions.properties) {
            const properties = this.modelOptions.properties.filter(predicate);
            if (properties && properties.length) {
                return properties;
            }
        }
        return defaultValue;
    }
    filterByFirst(predicate) {
        const properties = this.filterBy(predicate, null);
        return properties && properties.length ? properties[0] : null;
    }
}

class MetadataHelper {
    static get(modelClass) {
        return new Metadata(modelClass);
    }
    static forModel(modelClass) {
        const modelMetadata = Reflect.getMetadata(KEY_MODEL, modelClass);
        if (!modelMetadata) {
            throw new Error(`make sure the @Model decorator is present on the model ${modelClass.name}`);
        }
        return modelMetadata;
    }
    /**
     *
     * @param {ModelConstructor<T>} modelClass
     * @param {keyof T} propertyKey Either the name of the property or the name of the
     * @returns {PropertyMetadata<T>}
     */
    static forProperty(modelClass, propertyKey) {
        if (modelClass) {
            const modelMetadata = Reflect.getMetadata(KEY_MODEL, modelClass);
            if (modelClass && !modelMetadata) {
                throw new Error(`make sure the @Model decorator was added to the given modelClass ${Object.hasOwnProperty('name')
                    ? modelClass.name
                    : modelClass}, was not able to find model metadata`);
            }
            let options;
            if (modelMetadata.properties) {
                options = modelMetadata.properties.find(property => property.name === propertyKey || property.nameDb === propertyKey);
            }
            return options;
        }
        else {
            return null;
        }
    }
}

function hasGenericType(propertyMetadata) {
    return !!(propertyMetadata &&
        propertyMetadata.typeInfo &&
        propertyMetadata.typeInfo.genericTypes &&
        propertyMetadata.typeInfo.genericTypes.length);
}

//
// impl
//
// collection

function attributeNameReplacer(substring, ...args) {
    return `_at_${args[0]}`;
}

const BRACED_INDEX_REGEX = /\[(\d+)]/g;
/**
 * Creates a unique attribute value placeholder name to use in the expression
 *
 * @param {string} key
 * @param {string[]} existingValueNames
 * @returns {string} The unique attribute value placeholder name in respect to the given existing value names (no duplicates)
 */
function uniqAttributeValueName(key, existingValueNames) {
    key = key.replace(/\./g, '__').replace(BRACED_INDEX_REGEX, attributeNameReplacer);
    let potentialName = `:${key}`;
    let idx = 1;
    if (existingValueNames && existingValueNames.length) {
        while (existingValueNames.includes(potentialName)) {
            idx++;
            potentialName = `:${key}_${idx}`;
        }
    }
    return potentialName;
}

function mergeConditions(operator, conditionDefinitionFns) {
    return (expressionAttributeValues, metadata) => {
        const mergedCondition = {
            statement: '',
            attributeNames: {},
            attributeValues: {},
        };
        const statements = [];
        conditionDefinitionFns.forEach(conditionDefinitionFn => {
            // we can reuse the same for multiple conditions
            const condition = conditionDefinitionFn(expressionAttributeValues, metadata);
            Object.assign(mergedCondition.attributeNames, condition.attributeNames);
            // we need to make sure the value variable name is unique
            const attributeValues = mapKeys(condition.attributeValues, (value, key) => {
                const unique = uniqAttributeValueName(key.replace(':', ''), Object.keys(mergedCondition.attributeValues));
                if (key !== unique) {
                    condition.statement = condition.statement.replace(key, unique);
                }
                return unique;
            });
            Object.assign(mergedCondition.attributeValues, attributeValues);
            statements.push(condition.statement);
        });
        mergedCondition.statement = `(${statements.join(' ' + operator + ' ')})`;
        return mergedCondition;
    };
}

function and(...conditionDefinitionFns) {
    return mergeConditions('AND', conditionDefinitionFns);
}

function or(...conditionDefinitionFns) {
    return mergeConditions('OR', conditionDefinitionFns);
}

function not(conditionDefinitionFn) {
    return (expressionAttributeValues, metadata) => {
        const condition = conditionDefinitionFn(expressionAttributeValues, metadata);
        condition.statement = `NOT ${condition.statement}`;
        return condition;
    };
}

class BooleanMapper {
    fromDb(dbValue) {
        return dbValue.BOOL === true;
    }
    toDb(modelValue) {
        return { BOOL: modelValue };
    }
}

class CollectionMapper {
    // TODO add some validation rules based on propertyMetadata and returned value from db for sorted as example (SS -> sorted -> throw error)
    fromDb(attributeValue, propertyMetadata) {
        const explicitType = propertyMetadata && propertyMetadata.typeInfo ? propertyMetadata.typeInfo.type : null;
        if (attributeValue.SS) {
            const arr = attributeValue.SS;
            return explicitType && explicitType === Array ? arr : new Set(arr);
        }
        if (attributeValue.NS) {
            const arr = attributeValue.NS.map(item => parseFloat(item));
            return explicitType && explicitType === Array ? arr : new Set(arr);
        }
        if (attributeValue.BS) {
            const arr = attributeValue.BS;
            return explicitType && explicitType === Array ? arr : new Set(arr);
        }
        if (attributeValue.L) {
            let arr;
            if (propertyMetadata &&
                propertyMetadata.typeInfo &&
                propertyMetadata.typeInfo.genericTypes &&
                propertyMetadata.typeInfo.genericTypes.length) {
                arr = attributeValue.L.map(item => Mapper.fromDb(item.M, propertyMetadata.typeInfo.genericTypes[0]));
            }
            else {
                arr = attributeValue.L.map(value => Mapper.fromDbOne(value));
            }
            return explicitType && explicitType === Set ? new Set(arr) : arr;
        }
        throw new Error('No Collection Data (SS | NS | BS | L) was found in attribute data');
    }
    toDb(propertyValue, propertyMetadata) {
        if (Array.isArray(propertyValue) || Util.isSet(propertyValue)) {
            const attributeValue = {};
            let collectionType;
            if (propertyMetadata) {
                const explicitType = propertyMetadata && propertyMetadata.typeInfo ? propertyMetadata.typeInfo.type : null;
                switch (explicitType) {
                    case Array:
                        collectionType = 'L';
                        break;
                    case Set:
                        if (propertyMetadata.isSortedCollection) {
                            // only the L(ist) type preserves order
                            collectionType = 'L';
                        }
                        else {
                            if (propertyValue.size === 0) {
                                // if the type is Set defined by propertyMetadata and the value is empty return null type, empty set is not allowed
                                return { NULL: true };
                            }
                            else {
                                if (hasGenericType(propertyMetadata)) {
                                    // generic type of Set is defined, so decide based on the generic type which db set type should be used
                                    if (Util.isBufferType(propertyMetadata.typeInfo.genericTypes[0])) {
                                        collectionType = 'BS';
                                    }
                                    else {
                                        switch (propertyMetadata.typeInfo.genericTypes[0]) {
                                            case String:
                                                collectionType = 'SS';
                                                break;
                                            case Number:
                                                collectionType = 'NS';
                                                break;
                                            default:
                                                // fallback to list if the type is not one of String or Number
                                                collectionType = 'L';
                                        }
                                    }
                                }
                                else {
                                    // auto detect based on set item values
                                    collectionType = Util.detectCollectionType(propertyValue);
                                }
                            }
                        }
                        break;
                    default:
                        throw new Error(`only 'Array' and 'Set' are valid values for explicit type, found ${explicitType}`);
                }
            }
            else {
                // auto detect based on set item values
                collectionType = Util.detectCollectionType(propertyValue);
            }
            // convert to array if we deal with a set
            if (Util.isSet(propertyValue)) {
                propertyValue = Array.from(propertyValue);
            }
            // empty value is not allowed for Set and List (TODO check if true for lists)
            if (propertyValue.length === 0) {
                return null;
            }
            else {
                switch (collectionType) {
                    case 'SS':
                        attributeValue.SS = propertyValue;
                        break;
                    case 'NS':
                        attributeValue.NS = propertyValue.map((num) => num.toString());
                        break;
                    case 'BS':
                        attributeValue.BS = propertyValue;
                        break;
                    case 'L':
                        if (hasGenericType(propertyMetadata)) {
                            attributeValue.L = propertyValue.map(value => ({
                                M: Mapper.toDb(value, propertyMetadata.typeInfo.genericTypes[0]),
                            }));
                        }
                        else {
                            attributeValue.L = propertyValue.map(value => Mapper.toDbOne(value)).filter(value => value !== null);
                        }
                        break;
                    default:
                        throw new Error(`Collection type must be one of SS | NS | BS | L found type ${collectionType}`);
                }
                return attributeValue;
            }
        }
        else {
            throw new Error(`given value is not an array ${propertyValue}`);
        }
    }
}

class DateMapper {
    fromDb(attributeValue) {
        if (attributeValue.N) {
            return new Date(attributeValue.N);
        }
        else {
            throw new Error('there is no N(umber) value defiend on given attribute value');
        }
    }
    toDb(modelValue) {
        if (modelValue && modelValue instanceof Date) {
            return { N: modelValue.getTime().toString() };
        }
        else {
            throw new Error('the given model value must be an instance of Date');
        }
    }
}

/**
 * Enums are mapped to numbers
 */
class EnumMapper {
    constructor() {
    }
    toDb(value, propertyMetadata) {
        return { N: value.toString() };
    }
    fromDb(attributeValue) {
        return parseInt(attributeValue.N, 10);
    }
}

class MomentMapper {
    fromDb(value) {
        const parsed = moment(value.S, moment.ISO_8601);
        if (!parsed.isValid()) {
            throw new Error(`the value ${value} cannot be parsed into a valid moment date`);
        }
        return parsed;
    }
    toDb(value) {
        if (moment.isMoment(value)) {
            if (value.isValid()) {
                // always store in utc, default format is ISO_8601
                return {
                    S: value
                        .clone()
                        .utc()
                        .format(),
                };
            }
            else {
                throw new Error(`cannot map property value ${value}, because it is not a valid moment date`);
            }
        }
        else {
            throw new Error(`the value ${value} is not of type moment`);
        }
    }
}

class NullMapper {
    constructor() { }
    fromDb(value) {
        return null;
    }
    toDb(value) {
        return { NULL: true };
    }
}

class NumberMapper {
    fromDb(attributeValue) {
        if (attributeValue.N) {
            return Number.parseFloat(attributeValue.N);
        }
        else {
            throw new Error('there is no N(umber) value defiend on given attribute value');
        }
    }
    toDb(modelValue) {
        return { N: modelValue.toString() };
    }
}

class ObjectMapper {
    constructor() { }
    fromDb(val, propertyMetadata) {
        if (propertyMetadata && propertyMetadata.typeInfo && propertyMetadata.typeInfo.isCustom) {
            return Mapper.fromDb(val.M, propertyMetadata.typeInfo.type);
        }
        else {
            return Mapper.fromDb(val.M);
        }
    }
    toDb(modelValue, propertyMetadata) {
        let value;
        if (propertyMetadata && propertyMetadata.typeInfo && propertyMetadata.typeInfo.isCustom) {
            value = Mapper.toDb(modelValue, propertyMetadata.typeInfo.type);
        }
        else {
            value = Mapper.toDb(modelValue);
        }
        return { M: value };
    }
}

class StringMapper {
    constructor() {
    }
    fromDb(attributeValue) {
        if (attributeValue.S) {
            return attributeValue.S;
        }
        else {
            throw new Error('there is no S(tring) value defiend on given attribute value');
        }
    }
    toDb(modelValue) {
        // an empty string is not a valid value for string attribute
        if (modelValue === '' || modelValue === null || modelValue === undefined) {
            return null;
        }
        else {
            return { S: modelValue };
        }
    }
}

// import v1 from 'uuid'
// import debug from 'debug';
/**
 * For the base convertion we use the DynamoDB converter.
 * We have some special requirements for which we add our own logic.
 */
class Mapper {
    // static logger = debug('Mapper');
    static toDb(item, modelConstructor) {
        const mapped = {};
        if (modelConstructor) {
            const metadata = MetadataHelper.get(modelConstructor);
            /*
             * initialize possible properties with auto generated uuid
             */
            if (metadata) {
                metadata.getKeysWithUUID().forEach(propertyMetadata => {
                    if (!Reflect.get(item, propertyMetadata.name)) {
                        Reflect.set(item, propertyMetadata.name, Util.uuidv4());
                    }
                });
            }
        }
        const propertyNames = Object.getOwnPropertyNames(item) || [];
        propertyNames.forEach(propertyKey => {
            /*
             * 1) get the value of the property
             */
            const propertyDescriptor = Object.getOwnPropertyDescriptor(item, propertyKey);
            // use get accessor if available otherwise use value property of descriptor
            let propertyValue;
            if (propertyDescriptor.get) {
                propertyValue = propertyDescriptor.get();
            }
            else {
                propertyValue = propertyDescriptor.value;
            }
            /*
             * 2) decide how to map the property depending on type or value
             */
            let attributeValue;
            let propertyMetadata;
            if (modelConstructor) {
                propertyMetadata = MetadataHelper.forProperty(modelConstructor, propertyKey);
            }
            if (propertyMetadata) {
                if (propertyMetadata.transient) {
                    // skip transient property
                    // Mapper.logger.log('transient property -> skip')
                }
                else {
                    /*
                     * 3a) property metadata is defined
                     */
                    attributeValue = Mapper.toDbOne(propertyValue, propertyMetadata);
                }
            }
            else {
                /*
                 * 3b) no metadata found
                 */
                // let typeByConvention = Util.typeByConvention(propertyKey);
                // if (typeByConvention) {
                /*
                   * 4a) matches a convention
                   */
                // attributeValue = Mapper.mapperForConvention(typeByConvention).toDb(propertyValue);
                // } else {
                //   /*
                //    * 4b) no naming convention matches
                //    */
                attributeValue = Mapper.toDbOne(propertyValue);
                // }
            }
            if (attributeValue === undefined) {
                // no-op transient field, just ignore it
            }
            else if (attributeValue === null) {
                // empty values (string, set, list) will be ignored too
            }
            else {
                mapped[propertyMetadata ? propertyMetadata.nameDb : propertyKey] = attributeValue;
            }
        });
        return mapped;
    }
    static toDbOne(propertyValue, propertyMetadata) {
        const explicitType = propertyMetadata && propertyMetadata.typeInfo && propertyMetadata.typeInfo.isCustom
            ? propertyMetadata.typeInfo.type
            : null;
        const type = explicitType || Util.typeOf(propertyValue);
        // some basic validation
        // TODO add check for binary type which is valid for parition key
        if (propertyMetadata &&
            propertyMetadata.key &&
            propertyMetadata.key.type === 'HASH' &&
            !propertyMetadata.mapper &&
            type !== String &&
            type !== Number &&
            type !== Binary) {
            throw new Error(`make sure to define a custom mapper which returns a string or number value for partition key, type ${type} cannot be used as partition key, value = ${JSON.stringify(propertyValue)}`);
        }
        if (propertyMetadata && propertyMetadata.mapper) {
            // custom mapper
            if (explicitType) {
                // TODO what about customMapper.fromDb
                return new propertyMetadata.mapper().toDb(propertyValue, propertyMetadata);
            }
            else {
                return new propertyMetadata.mapper().toDb(propertyValue);
            }
        }
        else {
            // mapper by type
            if (explicitType) {
                return Mapper.forType(type).toDb(propertyValue, propertyMetadata);
            }
            else {
                return Mapper.forType(type).toDb(propertyValue);
            }
        }
    }
    static fromDb(attributeMap, modelClass) {
        const model = {};
        Object.getOwnPropertyNames(attributeMap).forEach(attributeName => {
            /*
             * 1) get the value of the property
             */
            const attributeValue = attributeMap[attributeName];
            /*
             * 2) decide how to map the property depending on type or value
             */
            let modelValue;
            let propertyMetadata;
            if (modelClass) {
                propertyMetadata = MetadataHelper.forProperty(modelClass, attributeName);
            }
            if (propertyMetadata) {
                if (propertyMetadata.transient) {
                    // skip transient property
                    // Mapper.logger.log('transient property -> skip')
                }
                else {
                    /*
                     * 3a) property metadata is defined
                     */
                    modelValue = Mapper.fromDbOne(attributeValue, propertyMetadata);
                }
            }
            else {
                /*
                 * 3b) no metadata found
                 */
                // let typeByConvention = Util.typeByConvention(propertyKey);
                // if (typeByConvention) {
                //   /*
                //    * 4a) matches a convention
                //    */
                //   modelValue = Mapper.mapperForConvention(typeByConvention).fromDb(attributeValue);
                // } else {
                /*
                   * 4b) no naming convention matches
                   */
                modelValue = Mapper.fromDbOne(attributeValue);
                // }
            }
            Reflect.set(model, propertyMetadata ? propertyMetadata.name : attributeName, modelValue);
            // throw new Error('don\'t know how to map without model class');
        });
        return model;
    }
    static fromDbOne(attributeValue, propertyMetadata) {
        const explicitType = propertyMetadata && propertyMetadata.typeInfo && propertyMetadata.typeInfo.isCustom
            ? propertyMetadata.typeInfo.type
            : null;
        const type = explicitType || Util.typeOfFromDb(attributeValue);
        // Mapper.logger.log(`mapFromDbOne for type ${type}`)
        if (explicitType) {
            return Mapper.forType(type).fromDb(attributeValue, propertyMetadata);
        }
        else {
            return Mapper.forType(type).fromDb(attributeValue);
        }
    }
    static forType(type) {
        if (!Mapper.mapperForType.has(type)) {
            let mapperForType;
            switch (type) {
                case String:
                    mapperForType = new StringMapper();
                    break;
                case Number:
                    mapperForType = new NumberMapper();
                    break;
                case Boolean:
                    mapperForType = new BooleanMapper();
                    break;
                case MomentType:
                    mapperForType = new MomentMapper();
                    break;
                case Date:
                    mapperForType = new DateMapper();
                    break;
                case EnumType:
                    mapperForType = new EnumMapper();
                    break;
                case Map:
                    // Maps support complex types as keys, we only support String & Number as Keys, otherwise a .toString() method should be implemented,
                    // so we now how to save a  key
                    // mapperForType = new MapMapper()
                    throw new Error('Map is not supported to be mapped for now');
                case Array:
                    mapperForType = new CollectionMapper();
                    break;
                case Set:
                    mapperForType = new CollectionMapper();
                    break;
                case Object:
                    mapperForType = new ObjectMapper();
                    break;
                case NullType:
                    mapperForType = new NullMapper();
                    break;
                case Binary:
                    // TODO add binary mapper
                    throw new Error('no mapper for binary type implemented yet');
                default:
                    mapperForType = new ObjectMapper();
            }
            this.mapperForType.set(type, mapperForType);
        }
        return this.mapperForType.get(type);
    }
}
Mapper.mapperForType = new Map();

const NESTED_ATTR_PATH_CAPTURED_REGEX = /([a-z]+)(?:\[(\d+)])?\.?/g;
const NESTED_ATTR_PATH_REGEX = /^.+((\[(\d+)])|(\.)).*$/;
// TODO review this with fresh mind
function resolveAttributeNames(attributePath, propertyMetadata) {
    let placeholder;
    // tslint:disable-next-line:no-shadowed-variable
    const attributeNames = {};
    if (NESTED_ATTR_PATH_REGEX.test(attributePath)) {
        // nested attribute with document path (map or list)
        let re;
        const namePlaceholders = [];
        // tslint:disable-next-line:no-conditional-assignment
        while ((re = NESTED_ATTR_PATH_CAPTURED_REGEX.exec(attributePath)) !== null) {
            const pathPart = re[1];
            const collectionIndex = re[2];
            let pathPartDb;
            // get propertyMetdata of nested attribute if available
            if (propertyMetadata) {
                pathPartDb = propertyMetadata.nameDb;
            }
            else {
                pathPartDb = pathPart;
            }
            attributeNames[`#${pathPartDb}`] = pathPart;
            if (collectionIndex !== undefined) {
                namePlaceholders.push(`#${pathPartDb}[${collectionIndex}]`);
            }
            else {
                namePlaceholders.push(`#${pathPartDb}`);
            }
        }
        placeholder = namePlaceholders.join('.');
    }
    else {
        // top level attribute
        let attrPathDb;
        if (propertyMetadata) {
            attrPathDb = propertyMetadata.nameDb;
        }
        else {
            attrPathDb = attributePath;
        }
        attributeNames[`#${attributePath}`] = attrPathDb;
        placeholder = `#${attributePath}`;
    }
    return {
        placeholder,
        attributeNames,
    };
}

const FUNCTION_OPERATORS = [
    'attribute_exists',
    'attribute_not_exists',
    'attribute_type',
    'begins_with',
    'contains',
    'IN',
    'BETWEEN',
];

/**
 * An operator can either be an comparator or a function, this method helps to check for function operator
 * @param {ConditionOperator} operator
 * @returns {boolean} Returns true if the operator is a function operator, false otherwise
 */
function isFunctionOperator(operator) {
    return FUNCTION_OPERATORS.includes(operator);
}

const NON_PARAM_FUNCTION_OPERATORS = ['attribute_exists', 'attribute_not_exists'];

/**
 *
 * @param {ConditionOperator} operator
 * @returns {boolean} Returns true for all function operators with no param false otherwise
 */
function isNoParamFunctionOperator(operator) {
    return NON_PARAM_FUNCTION_OPERATORS.includes(operator);
}

/**
 * Every expression condition operator has a predefined arity (amount) of function paramers, this method
 * returns this value
 *
 * @param {ConditionOperator} operator
 * @returns {number} The amount of required method parameters when calling an operator function
 */
function operatorParameterArity(operator) {
    if (isNoParamFunctionOperator(operator)) {
        return 0;
    }
    else {
        switch (operator) {
            case '=':
            case '>':
            case '>=':
            case '<':
            case '<=':
            case '<>':
            case 'begins_with':
            case 'attribute_type':
            case 'contains':
            case 'IN':
                return 1;
            case 'BETWEEN':
                return 2;
            default:
                throw new Error(`no parameter arity defined for opererator ${operator}`);
        }
    }
}

/**
 * TODO complete doc
 * see http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/Expressions.ConditionExpressions.html
 */
class ConditionExpressionBuilder {
    /**
     * Will create a condition which can be added to a request using the param object.
     * It will create the expression statement and the attribute names and values.
     *
     * @param {string} attributePath
     * @param {ConditionOperator} operator
     * @param {any[]} values Depending on the operator the amount of values differs
     * @param {string[]} existingValueNames If provided the existing names are used to make sure we have a unique name for the current attributePath
     * @param {Metadata<any>} metadata If provided we use the metadata to define the attribute name and use it to map the given value(s) to attributeValue(s)
     * @returns {ConditionExpression}
     */
    static buildFilterExpression(attributePath, operator, values$$1, existingValueNames, metadata) {
        // TODO investigate is there a use case for undefined desired to be a value
        // get rid of undefined values
        values$$1 = values$$1.filter(value => value !== undefined);
        // check if provided values are valid for given operator
        ConditionExpressionBuilder.validateValues(operator, values$$1);
        // load property metadat if model metadata was provided
        let propertyMetadata;
        if (metadata) {
            propertyMetadata = metadata.forProperty(attributePath);
        }
        /*
         * resolve placeholder and valuePlaceholder names (same as attributePath if it not already exists)
         * myProp -> #myProp for name placeholder and :myProp for value placeholder
         *
         * person[0] -> #person: person
         * person.list[0].age -> #person: person, #attr: attr, #age: age
         * person.age
         */
        const resolvedAttributeNames = resolveAttributeNames(attributePath, propertyMetadata);
        const valuePlaceholder = uniqAttributeValueName(attributePath, existingValueNames);
        /*
         * build the statement
         */
        let buildFilterFn;
        switch (operator) {
            case 'IN':
                buildFilterFn = curryRight(ConditionExpressionBuilder.buildInConditionExpression);
                break;
            case 'BETWEEN':
                buildFilterFn = curryRight(ConditionExpressionBuilder.buildBetweenConditionExpression);
                break;
            default:
                buildFilterFn = curryRight(ConditionExpressionBuilder.buildDefaultConditionExpression);
                buildFilterFn = buildFilterFn(operator);
        }
        return buildFilterFn(attributePath, resolvedAttributeNames.placeholder, valuePlaceholder, resolvedAttributeNames.attributeNames, values$$1, existingValueNames, propertyMetadata);
    }
    /**
     * IN expression is unlike all the others property the operand is an array of unwrapped values (not attribute values)
     *
     * @param {string} attributePath
     * @param {string[]} values
     * @param {string[]} existingValueNames
     * @param {PropertyMetadata<any>} propertyMetadata
     * @returns {ConditionExpression}
     */
    static buildInConditionExpression(attributePath, namePlaceholder, valuePlaceholder, attributeNames, values$$1, existingValueNames, propertyMetadata) {
        const mappedValues = Mapper.toDbOne(values$$1[0], propertyMetadata);
        const attributeValues = {};
        attributeValues[valuePlaceholder] = mappedValues;
        return {
            statement: `${namePlaceholder} IN (${Object.keys(attributeValues)})`,
            attributeNames,
            attributeValues,
        };
    }
    static buildBetweenConditionExpression(attributePath, namePlaceholder, valuePlaceholder, attributeNames, values$$1, existingValueNames, propertyMetadata) {
        const attributeValues = {};
        const mappedValue1 = Mapper.toDbOne(values$$1[0], propertyMetadata);
        const mappedValue2 = Mapper.toDbOne(values$$1[1], propertyMetadata);
        if (mappedValue1 === null || mappedValue2 === null) {
            throw new Error('make sure to provide an actual value for te BETWEEN operator');
        }
        const value2Placeholder = uniqAttributeValueName(attributePath, [valuePlaceholder].concat(existingValueNames || []));
        const statement = `${namePlaceholder} BETWEEN ${valuePlaceholder} AND ${value2Placeholder}`;
        attributeValues[valuePlaceholder] = mappedValue1;
        attributeValues[value2Placeholder] = mappedValue2;
        return {
            statement,
            attributeNames,
            attributeValues,
        };
    }
    static buildDefaultConditionExpression(attributePath, namePlaceholder, valuePlaceholder, attributeNames, values$$1, existingValueNames, propertyMetadata, operator) {
        let statement;
        let hasValue = true;
        if (isFunctionOperator(operator)) {
            if (isNoParamFunctionOperator(operator)) {
                statement = `${operator} (${namePlaceholder})`;
                hasValue = false;
            }
            else {
                statement = `${operator} (${namePlaceholder}, ${valuePlaceholder})`;
            }
        }
        else {
            statement = [namePlaceholder, operator, valuePlaceholder].join(' ');
        }
        const attributeValues = {};
        if (hasValue) {
            let value;
            switch (operator) {
                case 'contains':
                    value = ConditionExpressionBuilder.validateValueForContains(values$$1[0], propertyMetadata);
                    break;
                default:
                    value = Mapper.toDbOne(values$$1[0], propertyMetadata);
            }
            if (value) {
                attributeValues[valuePlaceholder] = value;
            }
        }
        return {
            statement,
            attributeNames,
            attributeValues,
        };
    }
    /**
     * TODO if propertyMetadata is available we could add some type check for example with operator IN the given values should all have the same type like the attribute
     * which should be checked
     *
     * Every operator requires a predefined arity of parameters, this method checks for the correct arity and throws an Error
     * if not correct
     *
     * @param {ConditionOperator} operator
     * @param {any[]} values The values which will be applied to the operator function implementation
     * @throws {Error} error Throws an error if the amount of values won't match the operator function parameter arity or
     * the given values is not an array
     */
    static validateValues(operator, values$$1) {
        if (values$$1 && Array.isArray(values$$1)) {
            // check for correct amount of values
            const parameterArity = operatorParameterArity(operator);
            if (values$$1.length !== parameterArity) {
                switch (operator) {
                    case 'IN':
                        throw new Error(`expected ${parameterArity} value(s) for operator ${operator}, this is not the right amount of method parameters for this operator (IN operator requires one value of array type)`);
                    default:
                        throw new Error(`expected ${parameterArity} value(s) for operator ${operator}, this is not the right amount of method parameters for this operator`);
                }
            }
            // some additional operator dependent validation
            switch (operator) {
                case 'BETWEEN':
                    // values must be the same type
                    if (Util.typeOf(values$$1[0]) !== Util.typeOf(values$$1[1])) {
                        throw new Error(`both values for operator BETWEEN must have the same type, got ${Util.typeOf(values$$1[0])} and ${Util.typeOf(values$$1[1])}`);
                    }
                    break;
            }
        }
        else {
            throw new Error('values must be of type Array');
        }
    }
    // TODO should we support other types than String, Number, Binary (can we search a boolean set for example with boolean as string?)
    static validateValueForContains(value, propertyMetadata) {
        let finalValue;
        if (propertyMetadata && propertyMetadata.typeInfo) {
            switch (propertyMetadata.typeInfo.type) {
                case Array:
                case Set:
                    if (propertyMetadata.typeInfo.genericTypes &&
                        propertyMetadata.typeInfo.genericTypes[0] !== String &&
                        propertyMetadata.typeInfo.genericTypes[0] !== Number &&
                        propertyMetadata.typeInfo.genericTypes[0] !== Binary) {
                        finalValue = { S: value.toString() };
                    }
                    else {
                        throw new Error('either generic type info is not defined or the generic type is not one of String, Number, Binary');
                    }
                    break;
                case String:
                case Number:
                case Binary:
                    finalValue = { S: value.toString() };
                    break;
                default:
                    throw new Error(`contains expression is not supported for type ${propertyMetadata.typeInfo.type}`);
            }
        }
        else {
            // no explicit type defined -> try to detect the type from value
            const type = Util.typeOf(value);
            if (type === String || type === Number || type === Binary) {
                finalValue = { S: value.toString() };
            }
            else {
                throw new Error(`contains expression is not supported for type ${type}`);
            }
        }
        return finalValue;
    }
}

class ParamUtil {
    static addExpression(expressionType, condition, params) {
        const expressionAttributeNames = Object.assign({}, condition.attributeNames, params.ExpressionAttributeNames);
        const expressionAttributeValues = Object.assign({}, condition.attributeValues, params.ExpressionAttributeValues);
        if (!isEmpty(expressionAttributeNames)) {
            params.ExpressionAttributeNames = expressionAttributeNames;
        }
        if (!isEmpty(expressionAttributeValues)) {
            params.ExpressionAttributeValues = expressionAttributeValues;
        }
        const expression = Reflect.get(params, expressionType);
        if (isString(expression)) {
            
            params[expressionType] = `${expression} AND ${condition.statement}`;
            // throw new Error(
            //   'please use the logical operators and / or / not to define complex expressions instead of just adding it the an existing condition'
            // )
        }
        else {
            
            params[expressionType] = condition.statement;
        }
    }
}

const OPERATOR_TO_ALIAS_MAP = {
    '=': ['equals', 'eq'],
    '<>': 'ne',
    '<=': 'lte',
    '<': 'lt',
    '>=': 'gte',
    '>': 'gt',
    attribute_not_exists: 'null',
    attribute_exists: 'notNull',
    attribute_type: 'type',
    contains: 'contains',
    IN: 'in',
    begins_with: 'beginsWith',
    BETWEEN: 'between',
};

/**
 *
 */
class RequestExpressionBuilder {
    /**
     * Adds a condition to the given query.
     *
     * @param {string} attributePath
     * @param {T} request
     * @param {PropertyMetadata<any>} propetyMetadata
     * @returns {RequestConditionFunction<T extends Request<any, any>>}
     */
    static addCondition(expressionType, attributePath, request, metadata) {
        const f = (operator) => {
            return (...values$$1) => {
                return RequestExpressionBuilder.doAddCondition(expressionType, attributePath, request, metadata, operator, ...values$$1);
            };
        };
        return RequestExpressionBuilder.createConditionFunctions(f);
    }
    static addSortKeyCondition(keyName, request, metadata) {
        const f = (operator) => {
            return (...values$$1) => {
                return RequestExpressionBuilder.doAddCondition('KeyConditionExpression', keyName, request, metadata, operator, ...values$$1);
            };
        };
        // only a subset of available operators are supported for sort keys
        return RequestExpressionBuilder.createConditionFunctions(f, '=', '<=', '<', '>', '>=', 'begins_with', 'BETWEEN');
    }
    static doAddCondition(expressionType, attributePath, request, metadata, operator, ...values$$1) {
        const copy = [...values$$1];
        const existingValueKeys = request.params.ExpressionAttributeValues
            ? Object.keys(request.params.ExpressionAttributeValues)
            : [];
        const condition = ConditionExpressionBuilder.buildFilterExpression(attributePath, operator, copy, existingValueKeys, metadata);
        ParamUtil.addExpression(expressionType, condition, request.params);
        return request;
    }
    static addPartitionKeyCondition(keyName, keyValue, request, metadata) {
        return RequestExpressionBuilder.addSortKeyCondition(keyName, request, metadata).equals(keyValue);
    }
    static propertyDefinitionFunction(attributePath) {
        const f = (operator) => {
            return (...values$$1) => {
                const copy = [...values$$1];
                const curried = curry(ConditionExpressionBuilder.buildFilterExpression);
                return curried(attributePath, operator, copy);
            };
        };
        return RequestExpressionBuilder.createConditionFunctions(f);
    }
    /**
     * Creates an object which contains callable functions for all aliases defined in CONDITION_OPERATOR_ALIAS or if operators parameter is defined,
     * for all the values included in operators
     *
     * @param {(operator: ConditionOperator) => any} impl The function which is called with the operator and returns a function which expects the value
     * for the condition. when executed the implementation defines what todo with the condition, just return it for example or add the condition to the request
     * parameters as another example
     *
     * @param {ConditionOperator} operators
     * @returns {T}
     */
    static createConditionFunctions(impl, ...operators) {
        const includedAlias = operators && operators.length ? operators : Object.keys(OPERATOR_TO_ALIAS_MAP);
        return includedAlias.reduce((result, operator) => {
            const alias = OPERATOR_TO_ALIAS_MAP[operator];
            if (Array.isArray(alias)) {
                alias.forEach(a => Reflect.set(result, a, impl(operator)));
            }
            else {
                Reflect.set(result, alias, impl(operator));
            }
            return result;
        }, {});
    }
}

function attribute(attributePath) {
    return RequestExpressionBuilder.propertyDefinitionFunction(attributePath);
}

class BaseRequest {
    constructor(dynamoRx, modelClazz, tableName) {
        this.dynamoRx = dynamoRx;
        if (modelClazz === null || modelClazz === undefined) {
            throw new Error("please provide the model clazz for the request, won't work otherwise");
        }
        this.modelClazz = modelClazz;
        this.params = {
            TableName: tableName,
        };
    }
    get metaData() {
        if (!this._metadata) {
            this._metadata = MetadataHelper.get(this.modelClazz);
        }
        return this._metadata;
    }
}

class Request extends BaseRequest {
    constructor(dynamoRx, modelClazz, tableName) {
        super(dynamoRx, modelClazz, tableName);
        this.limit(Request.DEFAULT_LIMIT);
    }
    /**
     *
     * @param key A map representing the start id which is included in next call, if null is delivered
     * startKey will be removed from params
     * @returns {Request}
     */
    exclusiveStartKey(key) {
        if (key) {
            this.params.ExclusiveStartKey = key;
        }
        else {
            delete this.params.ExclusiveStartKey;
        }
        return this;
    }
    index(indexName) {
        const index = this.metaData.getIndex(indexName);
        if (index) {
            this.params.IndexName = indexName;
        }
        else {
            throw new Error(`there is no index with name <${indexName}> defined for model ${this.modelClazz.name}`);
        }
        return this;
    }
    limit(limit) {
        if (limit === Request.INFINITE_LIMIT) {
            delete this.params.Limit;
        }
        else {
            if (limit !== null && limit !== undefined && limit > 0) {
                this.params.Limit = limit;
            }
            else {
                throw new Error('limit must be a valid positive number');
            }
        }
        return this;
    }
}
Request.DEFAULT_LIMIT = 10;
Request.INFINITE_LIMIT = -1;

// FIXME support more than just a query request
class PagedDataSource {
    // TODO better typing
    // TODO pagesize should be configurable
    constructor(request$, pageSize = 50) {
        this.pageSize = pageSize;
        this.loadingSubject = new BehaviorSubject$1(false);
        this.nextSubject = new Subject$1();
        this.metaSubject = new BehaviorSubject$1({ current: 0, total: 0, hasMore: false });
        this.data = [];
        this.loading$ = this.loadingSubject.asObservable();
        this.meta$ = this.metaSubject.asObservable();
        request$ = request$
            .do(() => this.reset())
            .publishReplay(1)
            .refCount();
        const count$ = request$
            .do(() => console.debug('fetch count'))
            .switchMap(request => request
            .limit(Request.INFINITE_LIMIT)
            .exclusiveStartKey(null)
            .execCount())
            .do(count => console.debug('got count', count))
            .share();
        const data$ = Observable$1.combineLatest(request$, this.nextSubject)
            .do(() => console.debug('request changed or next page was requested, call for data'))
            .map(values$$1 => values$$1[0])
            .switchMap(request => this.fetchData(request))
            .do(data => this.data.push(...data))
            .share();
        Observable$1.combineLatest(data$, count$)
            .map(values$$1 => {
            console.debug('data or count changed -> hasMore', this.data.length < values$$1[1]);
            return {
                current: this.data.length,
                total: values$$1[1],
                hasMore: this.data.length < values$$1[1],
            };
        })
            .share()
            .subscribe(meta => this.metaSubject.next(meta));
        const hasMore$ = this.meta$
            .map(meta => {
            return meta.hasMore;
        })
            .share();
        this.hasMore$ = hasMore$;
        this.count$ = count$;
        // subscribe to get it rolling
        data$.subscribe(() => console.debug('fetched data'), error => console.error('could not fetch data', error));
        // fetch the first set of data
        this.next();
    }
    next() {
        this.nextSubject.next();
    }
    /**
     * removes the given item if it exists in data set, and updates the counter.
     * @param item
     */
    removeItem(item) {
        const index = findIndex(this.data, item);
        if (index !== -1) {
            this.data.splice(index, 1);
            const meta = this.metaSubject.getValue();
            meta.current--;
            meta.total--;
            this.metaSubject.next(meta);
        }
        else {
            console.warn('the given item could not be found');
        }
    }
    addItem(item) {
        this.data.unshift(item);
        const meta = this.metaSubject.getValue();
        meta.current++;
        meta.total++;
        this.metaSubject.next(meta);
    }
    /**
     * will search for the item using _.findIndex(predicate) and replaces the found item with the updatedItem,
     * logs an error if the item to replace could not be found
     */
    editItem(updatedItem, predicate) {
        const index = findIndex(this.data, predicate);
        if (index !== -1) {
            this.data[index] = updatedItem;
        }
        else {
            console.error('could not find the item with predicate «%s»', predicate);
        }
    }
    reset() {
        console.debug('reset');
        this.data = [];
        this.lastKey = null;
    }
    fetchData(request) {
        console.debug('fetchData()');
        this.loadingSubject.next(true);
        return request
            .exclusiveStartKey(this.lastKey)
            .limit(this.pageSize)
            .execFullResponse()
            .do(response => {
            console.debug(response);
            // TODO maybe we should support undefined in request.exclusiveStartKey() expression
            this.lastKey = response.LastEvaluatedKey === undefined ? null : response.LastEvaluatedKey;
        })
            .map(response => response.Items || [])
            .finally(() => {
            console.debug('fetchData(): finally');
            this.loadingSubject.next(false);
        });
    }
}

class QueryRequest extends Request {
    constructor(dynamoRx, modelClazz, tableName) {
        super(dynamoRx, modelClazz, tableName);
    }
    wherePartitionKey(partitionKeyValue) {
        let partitionKey;
        if (this.params.IndexName) {
            const index = this.metaData.getIndex(this.params.IndexName);
            if (index) {
                partitionKey = index.partitionKey;
                if (!partitionKey) {
                    throw new Error(`there is no parition key defined for index <${this.params.IndexName}>`);
                }
            }
            else {
                throw new Error(`the index <${this.params.IndexName}> does not exist on model ${this.modelClazz.name}`);
            }
        }
        else {
            partitionKey = this.metaData.getPartitionKey();
        }
        return RequestExpressionBuilder.addSortKeyCondition(partitionKey, this, this.metaData).equals(partitionKeyValue);
    }
    /**
     * used to define some condition for the sort key, use the secondary index to query based on a custom index
     * @returns {RequestConditionFunction<T>}
     */
    whereSortKey() {
        let sortKey;
        if (this.params.IndexName) {
            const index = this.metaData.getIndex(this.params.IndexName);
            if (index) {
                if (index.sortKey) {
                    sortKey = index.sortKey;
                }
                else {
                    throw new Error(`there is no sort key defined for index <${this.params.IndexName}>`);
                }
            }
            else {
                throw new Error(`the index <${this.params.IndexName}> does not exist on model ${this.modelClazz.name}`);
            }
        }
        else {
            sortKey = this.metaData.getSortKey();
        }
        if (!sortKey) {
            throw new Error('There was no sort key defined for current schema');
        }
        return RequestExpressionBuilder.addSortKeyCondition(sortKey, this);
    }
    whereAttribute(attributePath) {
        return RequestExpressionBuilder.addCondition('FilterExpression', attributePath, this, this.metaData);
    }
    where(...conditionDefFns) {
        const condition = and(...conditionDefFns)(undefined, this.metaData);
        ParamUtil.addExpression('FilterExpression', condition, this.params);
        return this;
    }
    /**
     * multiple conditions will be combined using the AND operator by default
     * @param {ConditionExpression[]} conditions
     * @returns {QueryRequest<T>}
     *
     * TODO remove after investigation
     */
    // implementation with overload won't work perfectly with ide support, so we add two different methods
    // property(keyName: keyof T): RequestConditionFunction<QueryRequest<T>>
    // property(...conditionDefFns: ConditionExpressionDefinitionFunction[]): QueryRequest<T>
    //
    // // (keyof T)[] | ConditionExpressionDefinitionFunction[]
    // property(...args: any[]): RequestConditionFunction<QueryRequest<T>> | QueryRequest<T> {
    //   if (args.length === 1 && typeof args[0] === 'string') {
    //
    //   } else {
    //     const conditions: ConditionExpression[] = args.map((conditionDefFn: ConditionExpressionDefinitionFunction) => {
    //       return conditionDefFn(undefined, this.metaData)
    //     })
    //
    //     const condition = and(...conditions)
    //     ParamUtil.addFilterExpression(condition, this.params)
    //     return this
    //   }
    // }
    ascending() {
        this.params.ScanIndexForward = true;
        return this;
    }
    descending() {
        this.params.ScanIndexForward = false;
        return this;
    }
    execCount() {
        const params = Object.assign({}, this.params);
        params.Select = 'COUNT';
        return this.dynamoRx.query(params).map(response => response.Count);
    }
    execFullResponse() {
        return this.dynamoRx.query(this.params).map(queryResponse => {
            const response = Object.assign({}, queryResponse);
            response.Items = queryResponse.Items.map(item => Mapper.fromDb(item, this.modelClazz));
            return response;
        });
    }
    exec() {
        return (this.dynamoRx
            .query(this.params)
            .map(response => response.Items.map(item => Mapper.fromDb(item, this.modelClazz))));
    }
    execSingle() {
        this.limit(1);
        return this.dynamoRx.query(this.params).map(response => {
            if (response.Count) {
                return Mapper.fromDb(response.Items[0], this.modelClazz);
            }
            else {
                return null;
            }
        });
    }
}

class ScanRequest extends Request {
    constructor(dynamoRx, modelClazz, tableName) {
        super(dynamoRx, modelClazz, tableName);
    }
    whereAttribute(attributePath) {
        return RequestExpressionBuilder.addCondition('FilterExpression', attributePath, this, this.metaData);
    }
    where(...conditionDefFns) {
        const condition = and(...conditionDefFns)(undefined, this.metaData);
        ParamUtil.addExpression('FilterExpression', condition, this.params);
        return this;
    }
    execFullResponse() {
        delete this.params.Select;
        return this.dynamoRx.scan(this.params).map(queryResponse => {
            const response = Object.assign({}, queryResponse);
            response.Items = queryResponse.Items.map(item => Mapper.fromDb(item, this.modelClazz));
            return response;
        });
    }
    exec() {
        delete this.params.Select;
        return this.dynamoRx
            .scan(this.params)
            .map(response => response.Items.map(item => Mapper.fromDb(item, this.modelClazz)));
    }
    execSingle() {
        delete this.params.Select;
        return this.dynamoRx.scan(this.params).map(response => Mapper.fromDb(response.Items[0], this.modelClazz));
    }
    execCount() {
        const params = Object.assign({}, this.params);
        params.Select = 'COUNT';
        return this.dynamoRx.scan(params).map(response => response.Count);
    }
}

class DeleteRequest extends BaseRequest {
    constructor(dynamoRx, modelClazz, tableName, partitionKey, sortKey) {
        super(dynamoRx, modelClazz, tableName);
        const hasSortKey = this.metaData.getSortKey() !== null;
        if (hasSortKey && (sortKey === null || sortKey === undefined)) {
            throw new Error(`please provide the sort key for attribute ${this.metaData.getSortKey()}`);
        }
        const keyAttributeMap = {};
        // partition key
        const partitionKeyValue = Mapper.toDbOne(partitionKey, this.metaData.forProperty(this.metaData.getPartitionKey()));
        if (partitionKeyValue === null) {
            throw new Error('please provide an acutal value for partition key, got null');
        }
        keyAttributeMap[this.metaData.getPartitionKey()] = partitionKeyValue;
        // sort key
        if (hasSortKey) {
            const sortKeyValue = Mapper.toDbOne(sortKey, this.metaData.forProperty(this.metaData.getSortKey()));
            if (sortKeyValue === null) {
                throw new Error('please provide an actual value for sort key, got null');
            }
            keyAttributeMap[this.metaData.getSortKey()] = sortKeyValue;
        }
        this.params.Key = keyAttributeMap;
    }
    whereAttribute(attributePath) {
        return RequestExpressionBuilder.addCondition('ConditionExpression', attributePath, this, this.metaData);
    }
    where(...conditionDefFns) {
        const condition = and(...conditionDefFns)(undefined, this.metaData);
        ParamUtil.addExpression('ConditionExpression', condition, this.params);
        return this;
    }
    returnConsumedCapacity(level) {
        this.params.ReturnConsumedCapacity = level;
        return this;
    }
    returnItemCollectionMetrics(returnItemCollectionMetrics) {
        this.params.ReturnItemCollectionMetrics = returnItemCollectionMetrics;
        return this;
    }
    /*
       * The ReturnValues parameter is used by several DynamoDB operations; however,
       * DeleteItem does not recognize any values other than NONE or ALL_OLD.
       */
    returnValues(returnValues) {
        this.params.ReturnValues = returnValues;
        return this;
    }
    execFullResponse() {
        return this.dynamoRx.deleteItem(this.params);
    }
    exec() {
        return this.dynamoRx.deleteItem(this.params).map(response => {
            return;
        });
    }
}

class GetRequest extends BaseRequest {
    constructor(dynamoRx, modelClazz, tableName, partitionKey, sortKey) {
        super(dynamoRx, modelClazz, tableName);
        const hasSortKey = this.metaData.getSortKey() !== null;
        if (hasSortKey && (sortKey === null || sortKey === undefined)) {
            throw new Error(`please provide the sort key for attribute ${this.metaData.getSortKey()}`);
        }
        const keyAttributeMap = {};
        // partition key
        const partitionKeyValue = Mapper.toDbOne(partitionKey, this.metaData.forProperty(this.metaData.getPartitionKey()));
        if (partitionKeyValue === null) {
            throw new Error('please provide an acutal value for partition key, got null');
        }
        keyAttributeMap[this.metaData.getPartitionKey()] = partitionKeyValue;
        // sort key
        if (hasSortKey) {
            const sortKeyValue = Mapper.toDbOne(sortKey, this.metaData.forProperty(this.metaData.getSortKey()));
            if (sortKeyValue === null) {
                throw new Error('please provide an actual value for sort key, got null');
            }
            keyAttributeMap[this.metaData.getSortKey()] = sortKeyValue;
        }
        this.params.Key = keyAttributeMap;
    }
    consistentRead(consistendRead) {
        this.params.ConsistentRead = consistendRead;
        return this;
    }
    returnConsumedCapacity(level) {
        this.params.ReturnConsumedCapacity = level;
        return this;
    }
    // TODO review this
    projectionExpression(...attributesToGet) {
        const resolved = attributesToGet.map(attr => resolveAttributeNames(attr));
        this.params.ProjectionExpression = resolved.map(attr => attr.placeholder).join(', ');
        values(resolved).forEach(r => {
            this.params.ExpressionAttributeNames = Object.assign({}, this.params.ExpressionAttributeNames, r.attributeNames);
        });
        return this;
    }
    execFullResponse() {
        return this.dynamoRx.getItem(this.params).map(getItemResponse => {
            const response = Object.assign({}, getItemResponse);
            if (getItemResponse.Item) {
                response.Item = Mapper.fromDb(getItemResponse.Item, this.modelClazz);
            }
            else {
                response.Item = null;
            }
            return response;
        });
    }
    exec() {
        return this.dynamoRx.getItem(this.params).map(response => {
            if (response.Item) {
                return Mapper.fromDb(response.Item, this.modelClazz);
            }
            else {
                return null;
            }
        });
    }
}

class PutRequest extends BaseRequest {
    constructor(dynamoRx, modelClazz, tableName, item) {
        super(dynamoRx, modelClazz, tableName);
        this.params.Item = Mapper.toDb(item, this.modelClazz);
    }
    /**
     * Adds a condition expression to the request, which makes sure the item will only be saved if the id does not exist
     * @returns {PutRequest<T>}
     */
    ifNotExists(predicate) {
        // FIXME should we check for sort key too?
        // FIXME add test for predicate
        if (predicate === undefined || (predicate !== undefined && predicate === true)) {
            this.whereAttribute(this.metaData.getPartitionKey()).null();
        }
        return this;
    }
    returnConsumedCapacity(level) {
        this.params.ReturnConsumedCapacity = level;
        return this;
    }
    returnItemCollectionMetrics(returnItemCollectionMetrics) {
        this.params.ReturnItemCollectionMetrics = returnItemCollectionMetrics;
        return this;
    }
    /*
     * The ReturnValues parameter is used by several DynamoDB operations,
     * however, PutItem does not recognize any values other than NONE or ALL_OLD.
     */
    returnValues(returnValues) {
        this.params.ReturnValues = returnValues;
        return this;
    }
    whereAttribute(attributePath) {
        return RequestExpressionBuilder.addCondition('ConditionExpression', attributePath, this, this.metaData);
    }
    where(...conditionDefFns) {
        const condition = and(...conditionDefFns)(undefined, this.metaData);
        ParamUtil.addExpression('ConditionExpression', condition, this.params);
        return this;
    }
    execFullResponse() {
        return this.dynamoRx.putItem(this.params);
    }
    exec() {
        return this.dynamoRx.putItem(this.params).map(response => {
            return;
        });
    }
}

class UpdateRequest extends BaseRequest {
    constructor(dynamoRx, modelClazz, tableName, partitionKey, sortKey) {
        super(dynamoRx, modelClazz, tableName);
        const hasSortKey = this.metaData.getSortKey() !== null;
        if ((hasSortKey && sortKey === null) || sortKey === undefined) {
            throw new Error(`please provide the sort key for attribute ${this.metaData.getSortKey()}`);
        }
        const keyAttributeMap = {};
        // partition key
        const partitionKeyValue = Mapper.toDbOne(partitionKey, this.metaData.forProperty(this.metaData.getPartitionKey()));
        if (partitionKeyValue === null) {
            throw new Error('please provide an acutal value for partition key, got null');
        }
        keyAttributeMap[this.metaData.getPartitionKey()] = partitionKeyValue;
        // sort key
        if (hasSortKey) {
            const sortKeyValue = Mapper.toDbOne(sortKey, this.metaData.forProperty(this.metaData.getSortKey()));
            if (sortKeyValue === null) {
                throw new Error('please provide an actual value for sort key, got null');
            }
            keyAttributeMap[this.metaData.getSortKey()] = sortKeyValue;
        }
        this.params.Key = keyAttributeMap;
    }
    whereAttribute(attributePath) {
        return RequestExpressionBuilder.addCondition('FilterExpression', attributePath, this, this.metaData);
    }
    where(...conditionDefFns) {
        const condition = and(...conditionDefFns)(undefined, this.metaData);
        ParamUtil.addExpression('FilterExpression', condition, this.params);
        return this;
    }
    // TODO implement http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_UpdateItem.html#DDB-UpdateItem-request-UpdateExpression
    updateExpression(expression) {
        return this;
    }
    returnConsumedCapacity(level) {
        this.params.ReturnConsumedCapacity = level;
        return this;
    }
    returnItemCollectionMetrics(returnItemCollectionMetrics) {
        this.params.ReturnItemCollectionMetrics = returnItemCollectionMetrics;
        return this;
    }
    /*
     * The ReturnValues parameter is used by several DynamoDB operations; however,
     * DeleteItem does not recognize any values other than NONE or ALL_OLD.
     */
    returnValues(returnValues) {
        this.params.ReturnValues = returnValues;
        return this;
    }
    execFullResponse() {
        return this.dynamoRx.updateItem(this.params);
    }
    exec() {
        // TODO maybe we should map the returned Attributes to the given model type, needs some more investigation
        return this.dynamoRx.updateItem(this.params).map(response => {
            return;
        });
    }
}

/**
 * Simply brings the standard dynamodb operations into the rx world by wrapping the node callbacks into observables
 */
class DynamoRx {
    constructor(sessionValidtyEnsurer) {
        // this.logger = new Logger(() => LogLevel.DEBUG, 'DynamoDbService');
        // create the actual dynamo db client
        this.dynamoDb = new DynamoDB();
        this.sessionValidityEnsurer = sessionValidtyEnsurer;
    }
    updateAwsConfigCredentials(newConfig) {
        this.dynamoDb.config.update({ credentials: newConfig.credentials });
    }
    /*
     * make all the dynamo requests return an observable
     */
    putItem(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.putItem(params).promise()));
    }
    getItem(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.getItem(params).promise()));
    }
    updateItem(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.updateItem(params).promise()));
    }
    deleteItem(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.deleteItem(params).promise()));
    }
    batchWriteItem(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.batchWriteItem(params).promise()));
    }
    batchGetItems(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.batchGetItem(params).promise()));
    }
    scan(params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.scan(params).promise()));
    }
    query(params) {
        if (!params.KeyConditionExpression) {
            throw new Error('key condition expression must be defined');
        }
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.query(params).promise()));
    }
    makeRequest(operation, params) {
        return this.sessionValidityEnsurer().switchMap(() => Observable$1.fromPromise(this.dynamoDb.makeRequest(operation, params).promise()));
    }
}

/**
 * A simple no-op function which tells that we always have a valid session, which obviously requires some valid
 * session checking and also renewing of a potentially expired (or non existing) session
 * // todo add sample implementation
 *
 * @returns {Observable<any>}
 * @constructor
 */
const DEFAULT_SESSION_VALIDITY_ENSURERE = () => Observable$1.of(null).map(() => { return; });

const DEFAULT_TABLE_NAME_RESOLVER = (tableName) => tableName;

class DynamoStore {
    constructor(modelClazz, tableNameResolver = DEFAULT_TABLE_NAME_RESOLVER, sessionValidityEnsurer = DEFAULT_SESSION_VALIDITY_ENSURERE) {
        this.modelClazz = modelClazz;
        this.dynamoRx = new DynamoRx(sessionValidityEnsurer);
        this.tableName = tableNameResolver(MetadataHelper.get(this.modelClazz).modelOptions.tableName);
    }
    get dynamoDb() {
        return this.dynamoRx.dynamoDb;
    }
    put(item) {
        return new PutRequest(this.dynamoRx, this.modelClazz, this.tableName, item);
    }
    get(partitionKey, sortKey) {
        return new GetRequest(this.dynamoRx, this.modelClazz, this.tableName, partitionKey, sortKey);
    }
    update(partitionKey, sortKey) {
        return new UpdateRequest(this.dynamoRx, this.modelClazz, this.tableName, partitionKey, sortKey);
    }
    delete(partitionKey, sortKey) {
        return new DeleteRequest(this.dynamoRx, this.modelClazz, this.tableName, partitionKey, sortKey);
    }
    scan() {
        return new ScanRequest(this.dynamoRx, this.modelClazz, this.tableName);
    }
    query() {
        return new QueryRequest(this.dynamoRx, this.modelClazz, this.tableName);
    }
    makeRequest(operation, params) {
        return this.dynamoRx.makeRequest(operation, params);
    }
    /*
     * some methods which simplify calls which are usually often used
     * TODO review the methods
     */
    /**
     * executes a dynamoDB.batchGetItem for multiple keys or a operation
     *
     * @param {any[]} keys
     * @returns {Observable<T[]>}
     */
    byKeys(keys) {
        return this.findByMultipleKeys(keys);
    }
    findAll() {
        return this.scan().exec();
    }
    // TODO how does this work when we work with composite primary key
    findByMultipleKeys(keys) {
        const requestItems = {};
        const attributeMaps = [];
        keys.forEach(id => {
            // TODO add support for secondary index
            const idOb = {};
            const value = Mapper.toDbOne(id);
            if (value === null) {
                throw Error('please provide an actual value for partition key');
            }
            idOb[MetadataHelper.get(this.modelClazz).getPartitionKey()] = value;
            attributeMaps.push(idOb);
        });
        requestItems[this.tableName] = {
            Keys: attributeMaps,
        };
        const params = {
            RequestItems: requestItems,
        };
        return this.dynamoRx.batchGetItems(params).map(response => {
            if (response.Responses && Object.keys(response.Responses).length) {
                return response.Responses[this.tableName].map(attributeMap => Mapper.fromDb(attributeMap, this.modelClazz));
            }
            else {
                return [];
            }
        });
    }
    // private findBySingleKey(partitionKeyValue: any): Observable<T[]> {
    //   return this.query()
    //     .wherePartitionKey(partitionKeyValue)
    //     .exec()
    // }
    createBaseParams() {
        const params = {
            TableName: this.tableName,
        };
        return params;
    }
}

//
// Reflect Metadata
//
//
// MomentJs locales
//
//
// RxJs
//
//
/*
 * TODO add fluent api for updates
 * TODO add query builder for more complex queries QB.AND(QB.NOT(condition1), QB.OR(condition1, condition2...))
 */
class ScDynamoObjectMapper {
    constructor() { }
}
// FIXME make this configurable
ScDynamoObjectMapper.config = { dateType: 'moment' };

export { ScDynamoObjectMapper, SortedSet, TypedSet, TypedArray, Date$1 as Date, MomentType, GSIPartitionKey, GSISortKey, LSISortKey, IndexType, PartitionKey, PartitionKeyUUID, SortKey, CustomMapper, KEY_MODEL, Model, KEY_PROPERTY, Property, initOrUpdateIndex, initOrUpdateProperty, Transient, Enum, Metadata, MetadataHelper, hasGenericType, KEY_TYPE, KEY_PARAMETER, KEY_RETURN_TYPE, getMetadataType, makeMetadataGetter, and, or, not, attribute, PagedDataSource, QueryRequest, ScanRequest, Request, DeleteRequest, GetRequest, PutRequest, UpdateRequest, DynamoRx, DynamoStore, Mapper, EnumType, NullType, UndefinedType, Binary, Util, StringMapper, NumberMapper, BooleanMapper, CollectionMapper, DateMapper, MomentMapper, ObjectMapper, EnumMapper, NullMapper };
//# sourceMappingURL=sc-dynamo-object-mapper.es5.js.map
