import { KeyType } from 'aws-sdk/clients/dynamodb';
import { PropertyMetadata } from '../../metadata/property-metadata.model';
import { MomentType } from '../date/moment.type';
import { IndexType } from '../index/index-type.enum';
import { PropertyData } from './property-data.model';
export declare const KEY_PROPERTY = "sc-reflect:property";
export declare type AttributeModelTypes = string | number | boolean | Date | MomentType | Set<any> | any[];
export interface IndexData {
    name: string;
    keyType: KeyType;
}
export declare function Property(opts?: Partial<PropertyData>): PropertyDecorator;
export declare function initOrUpdateIndex(indexType: IndexType, indexData: IndexData, target: any, propertyKey: string): void;
export declare function initOrUpdateProperty(propertyMetadata: Partial<PropertyMetadata<any>> | undefined, target: any, propertyKey: string): void;
