import { ModelConstructor } from '../../model/model-constructor';
import { Metadata } from './metadata';
import { ModelMetadata } from './model-metadata.model';
import { PropertyMetadata } from './property-metadata.model';
export declare class MetadataHelper {
    static get<T>(modelClass: ModelConstructor<T>): Metadata<T>;
    static forModel<T>(modelClass: ModelConstructor<T>): ModelMetadata<T>;
    /**
     *
     * @param {ModelConstructor<T>} modelClass
     * @param {keyof T} propertyKey Either the name of the property or the name of the
     * @returns {PropertyMetadata<T>}
     */
    static forProperty<T>(modelClass: ModelConstructor<T>, propertyKey: keyof T | string): PropertyMetadata<T> | null | undefined;
}
