import { KeyType } from 'aws-sdk/clients/dynamodb';
import { MapperForType } from '../../mapper/for-type/base.mapper';
import { ModelConstructor } from '../../model/model-constructor';
export interface TypeInfo {
    type: ModelConstructor<any>;
    isCustom?: boolean;
    genericTypes?: Array<ModelConstructor<any>>;
}
export interface Key {
    type: KeyType;
    uuid?: boolean;
}
export interface PropertyMetadata<T> {
    key?: Key;
    name: keyof T;
    nameDb: string;
    typeInfo?: Partial<TypeInfo>;
    isSortedCollection?: boolean;
    mapper?: ModelConstructor<MapperForType<any>>;
    keyForGSI?: {
        [key: string]: KeyType;
    };
    sortKeyForLSI?: string[];
    transient?: boolean;
}
export declare function hasGenericType(propertyMetadata?: PropertyMetadata<any>): boolean;
