import { ScanInput } from 'aws-sdk/clients/dynamodb';
import { Observable } from 'rxjs/Observable';
import { ModelConstructor } from '../../../model/model-constructor';
import { DynamoRx } from '../../dynamo-rx';
import { ConditionExpressionDefinitionFunction } from '../../expression/type/condition-expression-definition-function';
import { RequestConditionFunction } from '../../expression/type/request-condition-function';
import { Pageable } from '../../paged/pageable';
import { Request } from '../request.model';
import { ScanResponse } from './scan.response';
export declare class ScanRequest<T> extends Request<T, ScanRequest<T>, ScanInput, ScanResponse<T>> implements Pageable<T, ScanRequest<T>, ScanResponse<T>> {
    constructor(dynamoRx: DynamoRx, modelClazz: ModelConstructor<T>, tableName: string);
    whereAttribute(attributePath: keyof T): RequestConditionFunction<ScanRequest<T>>;
    where(...conditionDefFns: ConditionExpressionDefinitionFunction[]): ScanRequest<T>;
    execFullResponse(): Observable<ScanResponse<T>>;
    exec(): Observable<T[]>;
    execSingle(): Observable<T | null>;
    execCount(): Observable<number>;
}
