import { AttributeMap, AttributeValue } from 'aws-sdk/clients/dynamodb';
import { PropertyMetadata } from '../decorator/metadata/property-metadata.model';
import { ModelConstructor } from '../model/model-constructor';
import { MapperForType } from './for-type/base.mapper';
import { AttributeModelType } from './type/attribute-model.type';
/**
 * For the base convertion we use the DynamoDB converter.
 * We have some special requirements for which we add our own logic.
 */
export declare class Mapper {
    static mapperForType: Map<AttributeModelType, MapperForType<any>>;
    static toDb<T>(item: T, modelConstructor?: ModelConstructor<T>): AttributeMap;
    static toDbOne(propertyValue: any, propertyMetadata?: PropertyMetadata<any>): AttributeValue | null;
    static fromDb<T>(attributeMap: AttributeMap, modelClass?: ModelConstructor<T>): T;
    static fromDbOne<T>(attributeValue: AttributeValue, propertyMetadata?: PropertyMetadata<any>): T;
    static forType(type: AttributeModelType): MapperForType<any>;
}
